/* Generated by re2c 0.14.3 */
/*
   +----------------------------------------------------------------------+
   | Zend Engine                                                          |
   +----------------------------------------------------------------------+
   | Copyright (c) Zend Technologies Ltd. (http://www.zend.com)           |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.00 of the Zend license,     |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.zend.com/license/2_00.txt.                                |
   | If you did not receive a copy of the Zend license and are unable to  |
   | obtain it through the world-wide-web, please send a note to          |
   | license@zend.com so we can mail you a copy immediately.              |
   +----------------------------------------------------------------------+
   | Authors: Marcus Boerger <helly@php.net>                              |
   |          Nuno Lopes <nlopess@php.net>                                |
   |          Scott MacVicar <scottmac@php.net>                           |
   | Flex version authors:                                                |
   |          Andi Gutmans <andi@php.net>                                 |
   |          Zeev Suraski <zeev@php.net>                                 |
   +----------------------------------------------------------------------+
*/

#if 0
# define YYDEBUG(s, c) printf("state: %d char: %c\n", s, c)
#else
# define YYDEBUG(s, c)
#endif

#include "zend_language_scanner_defs.h"

#include <errno.h>
#include "zend.h"
#ifdef ZEND_WIN32
# include <Winuser.h>
#endif
#include "zend_alloc.h"
#include <zend_language_parser.h>
#include "zend_compile.h"
#include "zend_language_scanner.h"
#include "zend_highlight.h"
#include "zend_constants.h"
#include "zend_variables.h"
#include "zend_operators.h"
#include "zend_API.h"
#include "zend_strtod.h"
#include "zend_exceptions.h"
#include "zend_virtual_cwd.h"

#define YYCTYPE   unsigned char
#define YYFILL(n) { if ((YYCURSOR + n) >= (YYLIMIT + ZEND_MMAP_AHEAD)) { return 0; } }
#define YYCURSOR  SCNG(yy_cursor)
#define YYLIMIT   SCNG(yy_limit)
#define YYMARKER  SCNG(yy_marker)

#define YYGETCONDITION()  SCNG(yy_state)
#define YYSETCONDITION(s) SCNG(yy_state) = s

#define STATE(name)  yyc##name

/* emulate flex constructs */
#define BEGIN(state) YYSETCONDITION(STATE(state))
#define YYSTATE      YYGETCONDITION()
#define yytext       ((char*)SCNG(yy_text))
#define yyleng       SCNG(yy_leng)
#define yyless(x)    do { YYCURSOR = (unsigned char*)yytext + x; \
                          yyleng   = (unsigned int)x; } while(0)
#define yymore()     goto yymore_restart

/* perform sanity check. If this message is triggered you should
   increase the ZEND_MMAP_AHEAD value in the zend_streams.h file */
#define YYMAXFILL 16
#if ZEND_MMAP_AHEAD < YYMAXFILL
# error ZEND_MMAP_AHEAD should be greater than or equal to YYMAXFILL
#endif

#include <stdarg.h>

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

/* Globals Macros */
#define SCNG	LANG_SCNG
#ifdef ZTS
ZEND_API ts_rsrc_id language_scanner_globals_id;
ZEND_API size_t language_scanner_globals_offset;
#else
ZEND_API zend_php_scanner_globals language_scanner_globals;
#endif

#define HANDLE_NEWLINES(s, l)													\
do {																			\
	char *p = (s), *boundary = p+(l);											\
																				\
	while (p<boundary) {														\
		if (*p == '\n' || (*p == '\r' && (*(p+1) != '\n'))) {					\
			CG(zend_lineno)++;													\
		}																		\
		p++;																	\
	}																			\
} while (0)

#define HANDLE_NEWLINE(c) \
{ \
	if (c == '\n' || c == '\r') { \
		CG(zend_lineno)++; \
	} \
}

/* To save initial string length after scanning to first variable */
#define SET_DOUBLE_QUOTES_SCANNED_LENGTH(len) SCNG(scanned_string_len) = (len)
#define GET_DOUBLE_QUOTES_SCANNED_LENGTH()    SCNG(scanned_string_len)

#define IS_LABEL_START(c) (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || (c) == '_' || (c) >= 0x80)
#define IS_LABEL_SUCCESSOR(c) (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || ((c) >= '0' && (c) <= '9') || (c) == '_' || (c) >= 0x80)

#define ZEND_IS_OCT(c)  ((c)>='0' && (c)<='7')
#define ZEND_IS_HEX(c)  (((c)>='0' && (c)<='9') || ((c)>='a' && (c)<='f') || ((c)>='A' && (c)<='F'))


static void strip_underscores(char *str, size_t *len)
{
	char *src = str, *dest = str;
	while (*src != '\0') {
		if (*src != '_') {
			*dest = *src;
			dest++;
		} else {
			--(*len);
		}
		src++;
	}
	*dest = '\0';
}

static size_t encoding_filter_script_to_internal(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	ZEND_ASSERT(internal_encoding);
	return zend_multibyte_encoding_converter(to, to_length, from, from_length, internal_encoding, LANG_SCNG(script_encoding));
}

static size_t encoding_filter_script_to_intermediate(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	return zend_multibyte_encoding_converter(to, to_length, from, from_length, zend_multibyte_encoding_utf8, LANG_SCNG(script_encoding));
}

static size_t encoding_filter_intermediate_to_script(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	return zend_multibyte_encoding_converter(to, to_length, from, from_length,
LANG_SCNG(script_encoding), zend_multibyte_encoding_utf8);
}

static size_t encoding_filter_intermediate_to_internal(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	ZEND_ASSERT(internal_encoding);
	return zend_multibyte_encoding_converter(to, to_length, from, from_length,
internal_encoding, zend_multibyte_encoding_utf8);
}


static void _yy_push_state(int new_state)
{
	zend_stack_push(&SCNG(state_stack), (void *) &YYGETCONDITION());
	YYSETCONDITION(new_state);
}

#define yy_push_state(state_and_tsrm) _yy_push_state(yyc##state_and_tsrm)

static void yy_pop_state(void)
{
	int *stack_state = zend_stack_top(&SCNG(state_stack));
	YYSETCONDITION(*stack_state);
	zend_stack_del_top(&SCNG(state_stack));
}

static void yy_scan_buffer(char *str, size_t len)
{
	YYCURSOR       = (YYCTYPE*)str;
	YYLIMIT        = YYCURSOR + len;
	if (!SCNG(yy_start)) {
		SCNG(yy_start) = YYCURSOR;
	}
}

void startup_scanner(void)
{
	CG(parse_error) = 0;
	CG(doc_comment) = NULL;
	CG(extra_fn_flags) = 0;
	zend_stack_init(&SCNG(state_stack), sizeof(int));
	zend_stack_init(&SCNG(nest_location_stack), sizeof(zend_nest_location));
	zend_ptr_stack_init(&SCNG(heredoc_label_stack));
	SCNG(heredoc_scan_ahead) = 0;
}

static void heredoc_label_dtor(zend_heredoc_label *heredoc_label) {
    efree(heredoc_label->label);
}

void shutdown_scanner(void)
{
	CG(parse_error) = 0;
	RESET_DOC_COMMENT();
	zend_stack_destroy(&SCNG(state_stack));
	zend_stack_destroy(&SCNG(nest_location_stack));
	zend_ptr_stack_clean(&SCNG(heredoc_label_stack), (void (*)(void *)) &heredoc_label_dtor, 1);
	zend_ptr_stack_destroy(&SCNG(heredoc_label_stack));
	SCNG(heredoc_scan_ahead) = 0;
	SCNG(on_event) = NULL;
}

ZEND_API void zend_save_lexical_state(zend_lex_state *lex_state)
{
	lex_state->yy_leng   = SCNG(yy_leng);
	lex_state->yy_start  = SCNG(yy_start);
	lex_state->yy_text   = SCNG(yy_text);
	lex_state->yy_cursor = SCNG(yy_cursor);
	lex_state->yy_marker = SCNG(yy_marker);
	lex_state->yy_limit  = SCNG(yy_limit);

	lex_state->state_stack = SCNG(state_stack);
	zend_stack_init(&SCNG(state_stack), sizeof(int));

	lex_state->nest_location_stack = SCNG(nest_location_stack);
	zend_stack_init(&SCNG(nest_location_stack), sizeof(zend_nest_location));

	lex_state->heredoc_label_stack = SCNG(heredoc_label_stack);
	zend_ptr_stack_init(&SCNG(heredoc_label_stack));

	lex_state->in = SCNG(yy_in);
	lex_state->yy_state = YYSTATE;
	lex_state->filename = CG(compiled_filename);
	lex_state->lineno = CG(zend_lineno);
	CG(compiled_filename) = NULL;

	lex_state->script_org = SCNG(script_org);
	lex_state->script_org_size = SCNG(script_org_size);
	lex_state->script_filtered = SCNG(script_filtered);
	lex_state->script_filtered_size = SCNG(script_filtered_size);
	lex_state->input_filter = SCNG(input_filter);
	lex_state->output_filter = SCNG(output_filter);
	lex_state->script_encoding = SCNG(script_encoding);

	lex_state->on_event = SCNG(on_event);
	lex_state->on_event_context = SCNG(on_event_context);

	lex_state->ast = CG(ast);
	lex_state->ast_arena = CG(ast_arena);
}

ZEND_API void zend_restore_lexical_state(zend_lex_state *lex_state)
{
	SCNG(yy_leng)   = lex_state->yy_leng;
	SCNG(yy_start)  = lex_state->yy_start;
	SCNG(yy_text)   = lex_state->yy_text;
	SCNG(yy_cursor) = lex_state->yy_cursor;
	SCNG(yy_marker) = lex_state->yy_marker;
	SCNG(yy_limit)  = lex_state->yy_limit;

	zend_stack_destroy(&SCNG(state_stack));
	SCNG(state_stack) = lex_state->state_stack;

	zend_stack_destroy(&SCNG(nest_location_stack));
	SCNG(nest_location_stack) = lex_state->nest_location_stack;

	zend_ptr_stack_clean(&SCNG(heredoc_label_stack), (void (*)(void *)) &heredoc_label_dtor, 1);
	zend_ptr_stack_destroy(&SCNG(heredoc_label_stack));
	SCNG(heredoc_label_stack) = lex_state->heredoc_label_stack;

	SCNG(yy_in) = lex_state->in;
	YYSETCONDITION(lex_state->yy_state);
	CG(zend_lineno) = lex_state->lineno;
	zend_restore_compiled_filename(lex_state->filename);

	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	SCNG(script_org) = lex_state->script_org;
	SCNG(script_org_size) = lex_state->script_org_size;
	SCNG(script_filtered) = lex_state->script_filtered;
	SCNG(script_filtered_size) = lex_state->script_filtered_size;
	SCNG(input_filter) = lex_state->input_filter;
	SCNG(output_filter) = lex_state->output_filter;
	SCNG(script_encoding) = lex_state->script_encoding;

	SCNG(on_event) = lex_state->on_event;
	SCNG(on_event_context) = lex_state->on_event_context;

	CG(ast) = lex_state->ast;
	CG(ast_arena) = lex_state->ast_arena;

	RESET_DOC_COMMENT();
}

ZEND_API zend_result zend_lex_tstring(zval *zv, unsigned char *ident)
{
	unsigned char *end = ident;
	while ((*end >= 'a' && *end <= 'z') || (*end >= 'A' && *end <= 'Z') || *end == '_') {
		end++;
	}

	size_t length = end - ident;
	if (length == 0) {
		ZEND_ASSERT(ident[0] == '<' && ident[1] == '?' && ident[2] == '=');
		zend_throw_exception(zend_ce_parse_error, "Cannot use \"<?=\" as an identifier", 0);
		return FAILURE;
	}

	if (SCNG(on_event)) {
		SCNG(on_event)(ON_FEEDBACK, T_STRING, 0, (char *) ident, length, SCNG(on_event_context));
	}

	ZVAL_STRINGL(zv, (char *) ident, length);
	return SUCCESS;
}

#define BOM_UTF32_BE	"\x00\x00\xfe\xff"
#define	BOM_UTF32_LE	"\xff\xfe\x00\x00"
#define	BOM_UTF16_BE	"\xfe\xff"
#define	BOM_UTF16_LE	"\xff\xfe"
#define	BOM_UTF8		"\xef\xbb\xbf"

static const zend_encoding *zend_multibyte_detect_utf_encoding(const unsigned char *script, size_t script_size)
{
	const unsigned char *p;
	int wchar_size = 2;
	int le = 0;

	/* utf-16 or utf-32? */
	p = script;
	assert(p >= script);
	while ((size_t)(p-script) < script_size) {
		p = memchr(p, 0, script_size-(p-script)-2);
		if (!p) {
			break;
		}
		if (*(p+1) == '\0' && *(p+2) == '\0') {
			wchar_size = 4;
			break;
		}

		/* searching for UTF-32 specific byte orders, so this will do */
		p += 4;
	}

	/* BE or LE? */
	p = script;
	assert(p >= script);
	while ((size_t)(p-script) < script_size) {
		if (*p == '\0' && *(p+wchar_size-1) != '\0') {
			/* BE */
			le = 0;
			break;
		} else if (*p != '\0' && *(p+wchar_size-1) == '\0') {
			/* LE* */
			le = 1;
			break;
		}
		p += wchar_size;
	}

	if (wchar_size == 2) {
		return le ? zend_multibyte_encoding_utf16le : zend_multibyte_encoding_utf16be;
	} else {
		return le ? zend_multibyte_encoding_utf32le : zend_multibyte_encoding_utf32be;
	}

	return NULL;
}

static const zend_encoding* zend_multibyte_detect_unicode(void)
{
	const zend_encoding *script_encoding = NULL;
	int bom_size;
	unsigned char *pos1, *pos2;

	if (LANG_SCNG(script_org_size) < sizeof(BOM_UTF32_LE)-1) {
		return NULL;
	}

	/* check out BOM */
	if (!memcmp(LANG_SCNG(script_org), BOM_UTF32_BE, sizeof(BOM_UTF32_BE)-1)) {
		script_encoding = zend_multibyte_encoding_utf32be;
		bom_size = sizeof(BOM_UTF32_BE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF32_LE, sizeof(BOM_UTF32_LE)-1)) {
		script_encoding = zend_multibyte_encoding_utf32le;
		bom_size = sizeof(BOM_UTF32_LE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF16_BE, sizeof(BOM_UTF16_BE)-1)) {
		script_encoding = zend_multibyte_encoding_utf16be;
		bom_size = sizeof(BOM_UTF16_BE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF16_LE, sizeof(BOM_UTF16_LE)-1)) {
		script_encoding = zend_multibyte_encoding_utf16le;
		bom_size = sizeof(BOM_UTF16_LE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF8, sizeof(BOM_UTF8)-1)) {
		script_encoding = zend_multibyte_encoding_utf8;
		bom_size = sizeof(BOM_UTF8)-1;
	}

	if (script_encoding) {
		/* remove BOM */
		LANG_SCNG(script_org) += bom_size;
		LANG_SCNG(script_org_size) -= bom_size;

		return script_encoding;
	}

	/* script contains NULL bytes -> auto-detection */
	if ((pos1 = memchr(LANG_SCNG(script_org), 0, LANG_SCNG(script_org_size)))) {
		/* check if the NULL byte is after the __HALT_COMPILER(); */
		pos2 = LANG_SCNG(script_org);

		while ((size_t)(pos1 - pos2) >= sizeof("__HALT_COMPILER();")-1) {
			pos2 = memchr(pos2, '_', pos1 - pos2);
			if (!pos2) break;
			pos2++;
			if (strncasecmp((char*)pos2, "_HALT_COMPILER", sizeof("_HALT_COMPILER")-1) == 0) {
				pos2 += sizeof("_HALT_COMPILER")-1;
				while (*pos2 == ' '  ||
					   *pos2 == '\t' ||
					   *pos2 == '\r' ||
					   *pos2 == '\n') {
					pos2++;
				}
				if (*pos2 == '(') {
					pos2++;
					while (*pos2 == ' '  ||
						   *pos2 == '\t' ||
						   *pos2 == '\r' ||
						   *pos2 == '\n') {
						pos2++;
					}
					if (*pos2 == ')') {
						pos2++;
						while (*pos2 == ' '  ||
							   *pos2 == '\t' ||
							   *pos2 == '\r' ||
							   *pos2 == '\n') {
							pos2++;
						}
						if (*pos2 == ';') {
							return NULL;
						}
					}
				}
			}
		}
		/* make best effort if BOM is missing */
		return zend_multibyte_detect_utf_encoding(LANG_SCNG(script_org), LANG_SCNG(script_org_size));
	}

	return NULL;
}

static const zend_encoding* zend_multibyte_find_script_encoding(void)
{
	const zend_encoding *script_encoding;

	if (CG(detect_unicode)) {
		/* check out bom(byte order mark) and see if containing wchars */
		script_encoding = zend_multibyte_detect_unicode();
		if (script_encoding != NULL) {
			/* bom or wchar detection is prior to 'script_encoding' option */
			return script_encoding;
		}
	}

	/* if no script_encoding specified, just leave alone */
	if (!CG(script_encoding_list) || !CG(script_encoding_list_size)) {
		return NULL;
	}

	/* if multiple encodings specified, detect automagically */
	if (CG(script_encoding_list_size) > 1) {
		return zend_multibyte_encoding_detector(LANG_SCNG(script_org), LANG_SCNG(script_org_size), CG(script_encoding_list), CG(script_encoding_list_size));
	}

	return CG(script_encoding_list)[0];
}

ZEND_API zend_result zend_multibyte_set_filter(const zend_encoding *onetime_encoding)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	const zend_encoding *script_encoding = onetime_encoding ? onetime_encoding: zend_multibyte_find_script_encoding();

	if (!script_encoding) {
		return FAILURE;
	}

	/* judge input/output filter */
	LANG_SCNG(script_encoding) = script_encoding;
	LANG_SCNG(input_filter) = NULL;
	LANG_SCNG(output_filter) = NULL;

	if (!internal_encoding || LANG_SCNG(script_encoding) == internal_encoding) {
		if (!zend_multibyte_check_lexer_compatibility(LANG_SCNG(script_encoding))) {
			/* and if not, work around w/ script_encoding -> utf-8 -> script_encoding conversion */
			LANG_SCNG(input_filter) = encoding_filter_script_to_intermediate;
			LANG_SCNG(output_filter) = encoding_filter_intermediate_to_script;
		} else {
			LANG_SCNG(input_filter) = NULL;
			LANG_SCNG(output_filter) = NULL;
		}
		return SUCCESS;
	}

	if (zend_multibyte_check_lexer_compatibility(internal_encoding)) {
		LANG_SCNG(input_filter) = encoding_filter_script_to_internal;
		LANG_SCNG(output_filter) = NULL;
	} else if (zend_multibyte_check_lexer_compatibility(LANG_SCNG(script_encoding))) {
		LANG_SCNG(input_filter) = NULL;
		LANG_SCNG(output_filter) = encoding_filter_script_to_internal;
	} else {
		/* both script and internal encodings are incompatible w/ flex */
		LANG_SCNG(input_filter) = encoding_filter_script_to_intermediate;
		LANG_SCNG(output_filter) = encoding_filter_intermediate_to_internal;
	}

	return SUCCESS;
}

ZEND_API zend_result open_file_for_scanning(zend_file_handle *file_handle)
{
	char *buf;
	size_t size;
	zend_string *compiled_filename;

	if (zend_stream_fixup(file_handle, &buf, &size) == FAILURE) {
		/* Still add it to open_files to make destroy_file_handle work */
		zend_llist_add_element(&CG(open_files), file_handle);
		file_handle->in_list = 1;
		return FAILURE;
	}

	ZEND_ASSERT(!EG(exception) && "stream_fixup() should have failed");
	zend_llist_add_element(&CG(open_files), file_handle);
	file_handle->in_list = 1;

	/* Reset the scanner for scanning the new file */
	SCNG(yy_in) = file_handle;
	SCNG(yy_start) = NULL;

	if (size != (size_t)-1) {
		if (CG(multibyte)) {
			SCNG(script_org) = (unsigned char*)buf;
			SCNG(script_org_size) = size;
			SCNG(script_filtered) = NULL;

			zend_multibyte_set_filter(NULL);

			if (SCNG(input_filter)) {
				if ((size_t)-1 == SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size))) {
					zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
							"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
				}
				buf = (char*)SCNG(script_filtered);
				size = SCNG(script_filtered_size);
			}
		}
		SCNG(yy_start) = (unsigned char *)buf;
		yy_scan_buffer(buf, size);
	} else {
		zend_error_noreturn(E_COMPILE_ERROR, "zend_stream_mmap() failed");
	}

	if (CG(skip_shebang)) {
		BEGIN(SHEBANG);
	} else {
		BEGIN(INITIAL);
	}

	if (file_handle->opened_path) {
		compiled_filename = zend_string_copy(file_handle->opened_path);
	} else {
		compiled_filename = zend_string_copy(file_handle->filename);
	}

	zend_set_compiled_filename(compiled_filename);
	zend_string_release_ex(compiled_filename, 0);

	RESET_DOC_COMMENT();
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	return SUCCESS;
}

static zend_op_array *zend_compile(int type)
{
	zend_op_array *op_array = NULL;
	bool original_in_compilation = CG(in_compilation);

	CG(in_compilation) = 1;
	CG(ast) = NULL;
	CG(ast_arena) = zend_arena_create(1024 * 32);

	if (!zendparse()) {
		int last_lineno = CG(zend_lineno);
		zend_file_context original_file_context;
		zend_oparray_context original_oparray_context;
		zend_op_array *original_active_op_array = CG(active_op_array);

		op_array = emalloc(sizeof(zend_op_array));
		init_op_array(op_array, type, INITIAL_OP_ARRAY_SIZE);
		CG(active_op_array) = op_array;

		/* Use heap to not waste arena memory */
		op_array->fn_flags |= ZEND_ACC_HEAP_RT_CACHE;

		if (zend_ast_process) {
			zend_ast_process(CG(ast));
		}

		zend_file_context_begin(&original_file_context);
		zend_oparray_context_begin(&original_oparray_context);
		zend_compile_top_stmt(CG(ast));
		CG(zend_lineno) = last_lineno;
		zend_emit_final_return(type == ZEND_USER_FUNCTION);
		op_array->line_start = 1;
		op_array->line_end = last_lineno;
		zend_init_static_variables_map_ptr(op_array);
		pass_two(op_array);
		zend_oparray_context_end(&original_oparray_context);
		zend_file_context_end(&original_file_context);

		CG(active_op_array) = original_active_op_array;
	}

	zend_ast_destroy(CG(ast));
	zend_arena_destroy(CG(ast_arena));

	CG(in_compilation) = original_in_compilation;

	return op_array;
}

ZEND_API zend_op_array *compile_file(zend_file_handle *file_handle, int type)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = NULL;
	zend_save_lexical_state(&original_lex_state);

	if (open_file_for_scanning(file_handle)==FAILURE) {
		if (!EG(exception)) {
			if (type==ZEND_REQUIRE) {
				zend_message_dispatcher(ZMSG_FAILED_REQUIRE_FOPEN, ZSTR_VAL(file_handle->filename));
			} else {
				zend_message_dispatcher(ZMSG_FAILED_INCLUDE_FOPEN, ZSTR_VAL(file_handle->filename));
			}
		}
	} else {
		op_array = zend_compile(ZEND_USER_FUNCTION);
	}

	zend_restore_lexical_state(&original_lex_state);
	return op_array;
}

ZEND_API zend_ast *zend_compile_string_to_ast(
		zend_string *code, zend_arena **ast_arena, zend_string *filename) {
	zval code_zv;
	bool original_in_compilation;
	zend_lex_state original_lex_state;
	zend_ast *ast;

	ZVAL_STR_COPY(&code_zv, code);

	original_in_compilation = CG(in_compilation);
	CG(in_compilation) = 1;

	zend_save_lexical_state(&original_lex_state);
	zend_prepare_string_for_scanning(&code_zv, filename);
	CG(ast) = NULL;
	CG(ast_arena) = zend_arena_create(1024 * 32);
	LANG_SCNG(yy_state) = yycINITIAL;

	if (zendparse() != 0) {
		zend_ast_destroy(CG(ast));
		zend_arena_destroy(CG(ast_arena));
		CG(ast) = NULL;
	}

	/* restore_lexical_state changes CG(ast) and CG(ast_arena) */
	ast = CG(ast);
	*ast_arena = CG(ast_arena);

	zend_restore_lexical_state(&original_lex_state);
	CG(in_compilation) = original_in_compilation;

	zval_ptr_dtor_str(&code_zv);

	return ast;
}

zend_op_array *compile_filename(int type, zend_string *filename)
{
	zend_file_handle file_handle;
	zend_op_array *retval;
	zend_string *opened_path = NULL;

	zend_stream_init_filename_ex(&file_handle, filename);

	retval = zend_compile_file(&file_handle, type);
	if (retval && file_handle.handle.stream.handle) {
		if (!file_handle.opened_path) {
			file_handle.opened_path = opened_path = zend_string_copy(filename);
		}

		zend_hash_add_empty_element(&EG(included_files), file_handle.opened_path);

		if (opened_path) {
			zend_string_release_ex(opened_path, 0);
		}
	}
	zend_destroy_file_handle(&file_handle);

	return retval;
}

ZEND_API void zend_prepare_string_for_scanning(zval *str, zend_string *filename)
{
	char *buf;
	size_t size, old_len;

	/* enforce ZEND_MMAP_AHEAD trailing NULLs for flex... */
	old_len = Z_STRLEN_P(str);
	Z_STR_P(str) = zend_string_extend(Z_STR_P(str), old_len + ZEND_MMAP_AHEAD, 0);
	Z_TYPE_INFO_P(str) = IS_STRING_EX;
	memset(Z_STRVAL_P(str) + old_len, 0, ZEND_MMAP_AHEAD + 1);

	SCNG(yy_in) = NULL;
	SCNG(yy_start) = NULL;

	buf = Z_STRVAL_P(str);
	size = old_len;

	if (CG(multibyte)) {
		SCNG(script_org) = (unsigned char*)buf;
		SCNG(script_org_size) = size;
		SCNG(script_filtered) = NULL;

		zend_multibyte_set_filter(zend_multibyte_get_internal_encoding());

		if (SCNG(input_filter)) {
			if ((size_t)-1 == SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size))) {
				zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
						"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
			}
			buf = (char*)SCNG(script_filtered);
			size = SCNG(script_filtered_size);
		}
	}

	yy_scan_buffer(buf, size);
	zend_set_compiled_filename(filename);
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	RESET_DOC_COMMENT();
}


ZEND_API size_t zend_get_scanned_file_offset(void)
{
	size_t offset = SCNG(yy_cursor) - SCNG(yy_start);
	if (SCNG(input_filter)) {
		size_t original_offset = offset, length = 0;
		do {
			unsigned char *p = NULL;
			if ((size_t)-1 == SCNG(input_filter)(&p, &length, SCNG(script_org), offset)) {
				return (size_t)-1;
			}
			efree(p);
			if (length > original_offset) {
				offset--;
			} else if (length < original_offset) {
				offset++;
			}
		} while (original_offset != length);
	}
	return offset;
}

zend_op_array *compile_string(zend_string *source_string, const char *filename)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = NULL;
	zval tmp;
	zend_string *filename_str;

	if (ZSTR_LEN(source_string) == 0) {
		return NULL;
	}

	ZVAL_STR_COPY(&tmp, source_string);

	zend_save_lexical_state(&original_lex_state);
	filename_str = zend_string_init(filename, strlen(filename), 0);
	zend_prepare_string_for_scanning(&tmp, filename_str);
	zend_string_release(filename_str);
	BEGIN(ST_IN_SCRIPTING);
	op_array = zend_compile(ZEND_EVAL_CODE);

	zend_restore_lexical_state(&original_lex_state);
	zval_ptr_dtor(&tmp);

	return op_array;
}


zend_result highlight_file(const char *filename, zend_syntax_highlighter_ini *syntax_highlighter_ini)
{
	zend_lex_state original_lex_state;
	zend_file_handle file_handle;

	zend_stream_init_filename(&file_handle, filename);
	zend_save_lexical_state(&original_lex_state);
	if (open_file_for_scanning(&file_handle)==FAILURE) {
		zend_message_dispatcher(ZMSG_FAILED_HIGHLIGHT_FOPEN, filename);
		zend_destroy_file_handle(&file_handle);
		zend_restore_lexical_state(&original_lex_state);
		return FAILURE;
	}
	zend_highlight(syntax_highlighter_ini);
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	zend_destroy_file_handle(&file_handle);
	zend_restore_lexical_state(&original_lex_state);
	return SUCCESS;
}

void highlight_string(zend_string *str, zend_syntax_highlighter_ini *syntax_highlighter_ini, const char *filename)
{
	zend_lex_state original_lex_state;
	zval str_zv;
	zend_string *filename_str = zend_string_init(filename, strlen(filename), 0);
	ZVAL_STR_COPY(&str_zv, str);
	zend_save_lexical_state(&original_lex_state);
	zend_prepare_string_for_scanning(&str_zv, filename_str);
	zend_string_release(filename_str);
	BEGIN(INITIAL);
	zend_highlight(syntax_highlighter_ini);
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	zend_restore_lexical_state(&original_lex_state);
	zval_ptr_dtor(&str_zv);
}

ZEND_API void zend_multibyte_yyinput_again(zend_encoding_filter old_input_filter, const zend_encoding *old_encoding)
{
	size_t length;
	unsigned char *new_yy_start;

	/* convert and set */
	if (!SCNG(input_filter)) {
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
			SCNG(script_filtered) = NULL;
		}
		SCNG(script_filtered_size) = 0;
		length = SCNG(script_org_size);
		new_yy_start = SCNG(script_org);
	} else {
		if ((size_t)-1 == SCNG(input_filter)(&new_yy_start, &length, SCNG(script_org), SCNG(script_org_size))) {
			zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
					"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
		}
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
		}
		SCNG(script_filtered) = new_yy_start;
		SCNG(script_filtered_size) = length;
	}

	SCNG(yy_cursor) = new_yy_start + (SCNG(yy_cursor) - SCNG(yy_start));
	SCNG(yy_marker) = new_yy_start + (SCNG(yy_marker) - SCNG(yy_start));
	SCNG(yy_text) = new_yy_start + (SCNG(yy_text) - SCNG(yy_start));
	SCNG(yy_limit) = new_yy_start + length;

	SCNG(yy_start) = new_yy_start;
}


// TODO: avoid reallocation ???
# define zend_copy_value(zendlval, yytext, yyleng) \
	if (SCNG(output_filter)) { \
		size_t sz = 0; \
		char *s = NULL; \
		SCNG(output_filter)((unsigned char **)&s, &sz, (unsigned char *)yytext, (size_t)yyleng); \
		ZVAL_STRINGL(zendlval, s, sz); \
		efree(s); \
	} else if (yyleng == 1) { \
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*(yytext))); \
	} else { \
		ZVAL_STRINGL(zendlval, yytext, yyleng); \
	}

static zend_result zend_scan_escape_string(zval *zendlval, char *str, int len, char quote_type)
{
	char *s, *t;
	char *end;

	if (len <= 1) {
		if (len < 1) {
			ZVAL_EMPTY_STRING(zendlval);
		} else {
			zend_uchar c = (zend_uchar)*str;
			if (c == '\n' || c == '\r') {
				CG(zend_lineno)++;
			}
			ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR(c));
		}
		goto skip_escape_conversion;
	}

	ZVAL_STRINGL(zendlval, str, len);

	/* convert escape sequences */
	s = Z_STRVAL_P(zendlval);
	end = s+Z_STRLEN_P(zendlval);
	while (1) {
		if (UNEXPECTED(*s=='\\')) {
			break;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
		if (s == end) {
			goto skip_escape_conversion;
		}
	}

	t = s;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (s >= end) {
				*t++ = '\\';
				break;
			}

			switch(*s) {
				case 'n':
					*t++ = '\n';
					break;
				case 'r':
					*t++ = '\r';
					break;
				case 't':
					*t++ = '\t';
					break;
				case 'f':
					*t++ = '\f';
					break;
				case 'v':
					*t++ = '\v';
					break;
				case 'e':
#ifdef ZEND_WIN32
					*t++ = VK_ESCAPE;
#else
					*t++ = '\e';
#endif
					break;
				case '"':
				case '`':
					if (*s != quote_type) {
						*t++ = '\\';
						*t++ = *s;
						break;
					}
					ZEND_FALLTHROUGH;
				case '\\':
				case '$':
					*t++ = *s;
					break;
				case 'x':
				case 'X':
					if (ZEND_IS_HEX(*(s+1))) {
						char hex_buf[3] = { 0, 0, 0 };

						hex_buf[0] = *(++s);
						if (ZEND_IS_HEX(*(s+1))) {
							hex_buf[1] = *(++s);
						}
						*t++ = (char) ZEND_STRTOL(hex_buf, NULL, 16);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
				/* UTF-8 codepoint escape, format: /\\u\{\x+\}/ */
				case 'u':
					{
						/* cache where we started so we can parse after validating */
						char *start = s + 1;
						size_t len = 0;
						bool valid = 1;
						unsigned long codepoint;

						if (*start != '{') {
							/* we silently let this pass to avoid breaking code
							 * with JSON in string literals (e.g. "\"\u202e\""
							 */
							*t++ = '\\';
							*t++ = 'u';
							break;
						} else {
							/* on the other hand, invalid \u{blah} errors */
							s++;
							len++;
							s++;
							while (*s != '}') {
								if (!ZEND_IS_HEX(*s)) {
									valid = 0;
									break;
								} else {
									len++;
								}
								s++;
							}
							if (*s == '}') {
								valid = 1;
								len++;
							}
						}

						/* \u{} is invalid */
						if (len <= 2) {
							valid = 0;
						}

						if (!valid) {
							zend_throw_exception(zend_ce_parse_error,
								"Invalid UTF-8 codepoint escape sequence", 0);
							zval_ptr_dtor(zendlval);
							ZVAL_UNDEF(zendlval);
							return FAILURE;
						}

						errno = 0;
						codepoint = strtoul(start + 1, NULL, 16);

						/* per RFC 3629, UTF-8 can only represent 21 bits */
						if (codepoint > 0x10FFFF || errno) {
							zend_throw_exception(zend_ce_parse_error,
								"Invalid UTF-8 codepoint escape sequence: Codepoint too large", 0);
							zval_ptr_dtor(zendlval);
							ZVAL_UNDEF(zendlval);
							return FAILURE;
						}

						/* based on https://en.wikipedia.org/wiki/UTF-8#Sample_code */
						if (codepoint < 0x80) {
							*t++ = codepoint;
						} else if (codepoint <= 0x7FF) {
							*t++ = (codepoint >> 6) + 0xC0;
							*t++ = (codepoint & 0x3F) + 0x80;
						} else if (codepoint <= 0xFFFF) {
							*t++ = (codepoint >> 12) + 0xE0;
							*t++ = ((codepoint >> 6) & 0x3F) + 0x80;
							*t++ = (codepoint & 0x3F) + 0x80;
						} else if (codepoint <= 0x10FFFF) {
							*t++ = (codepoint >> 18) + 0xF0;
							*t++ = ((codepoint >> 12) & 0x3F) + 0x80;
							*t++ = ((codepoint >> 6) & 0x3F) + 0x80;
							*t++ = (codepoint & 0x3F) + 0x80;
						}
					}
					break;
				default:
					/* check for an octal */
					if (ZEND_IS_OCT(*s)) {
						char octal_buf[4] = { 0, 0, 0, 0 };

						octal_buf[0] = *s;
						if (ZEND_IS_OCT(*(s+1))) {
							octal_buf[1] = *(++s);
							if (ZEND_IS_OCT(*(s+1))) {
								octal_buf[2] = *(++s);
							}
						}
						if (octal_buf[2] && (octal_buf[0] > '3') && !SCNG(heredoc_scan_ahead)) {
							/* 3 octit values must not overflow 0xFF (\377) */
							zend_error(E_COMPILE_WARNING, "Octal escape sequence overflow \\%s is greater than \\377", octal_buf);
						}

						*t++ = (char) ZEND_STRTOL(octal_buf, NULL, 8);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
	Z_STRLEN_P(zendlval) = t - Z_STRVAL_P(zendlval);

skip_escape_conversion:
	if (SCNG(output_filter)) {
		size_t sz = 0;
		unsigned char *str;
		// TODO: avoid realocation ???
		s = Z_STRVAL_P(zendlval);
		SCNG(output_filter)(&str, &sz, (unsigned char *)s, (size_t)Z_STRLEN_P(zendlval));
		zval_ptr_dtor(zendlval);
		ZVAL_STRINGL(zendlval, (char *) str, sz);
		efree(str);
	}
	return SUCCESS;
}

#define HEREDOC_USING_SPACES 1
#define HEREDOC_USING_TABS 2

static const char *next_newline(const char *str, const char *end, size_t *newline_len) {
	for (; str < end; str++) {
		if (*str == '\r') {
			*newline_len = str + 1 < end && *(str + 1) == '\n' ? 2 : 1;
			return str;
		} else if (*str == '\n') {
			*newline_len = 1;
			return str;
		}
	}
	*newline_len = 0;
	return NULL;
}

static bool strip_multiline_string_indentation(
	zval *zendlval, int indentation, bool using_spaces,
	bool newline_at_start, bool newline_at_end)
{
	const char *str = Z_STRVAL_P(zendlval), *end = str + Z_STRLEN_P(zendlval);
	char *copy = Z_STRVAL_P(zendlval);

	int newline_count = 0;
	size_t newline_len;
	const char *nl;

	if (!newline_at_start) {
		nl = next_newline(str, end, &newline_len);
		if (!nl) {
			return 1;
		}

		str = nl + newline_len;
		copy = (char *) nl + newline_len;
		newline_count++;
	} else {
		nl = str;
	}

	/* <= intentional */
	while (str <= end && nl) {
		size_t skip;
		nl = next_newline(str, end, &newline_len);
		if (!nl && newline_at_end) {
			nl = end;
		}

		/* Try to skip indentation */
		for (skip = 0; skip < indentation; skip++, str++) {
			if (str == nl) {
				/* Don't require full indentation on whitespace-only lines */
				break;
			}

			if (str == end || (*str != ' ' && *str != '\t')) {
				CG(zend_lineno) += newline_count;
				zend_throw_exception_ex(zend_ce_parse_error, 0,
					"Invalid body indentation level (expecting an indentation level of at least %d)", indentation);
				goto error;
			}

			if ((!using_spaces && *str == ' ') || (using_spaces && *str == '\t')) {
				CG(zend_lineno) += newline_count;
				zend_throw_exception(zend_ce_parse_error,
					"Invalid indentation - tabs and spaces cannot be mixed", 0);
				goto error;
			}
		}

		if (str == end) {
			break;
		}

		size_t len = nl ? (nl - str + newline_len) : (end - str);
		memmove(copy, str, len);
		str += len;
		copy += len;
		newline_count++;
	}

	*copy = '\0';
	Z_STRLEN_P(zendlval) = copy - Z_STRVAL_P(zendlval);
	return 1;

error:
	zval_ptr_dtor_str(zendlval);
	ZVAL_UNDEF(zendlval);

	return 0;
}

static void copy_heredoc_label_stack(void *void_heredoc_label)
{
	zend_heredoc_label *heredoc_label = void_heredoc_label;
	zend_heredoc_label *new_heredoc_label = emalloc(sizeof(zend_heredoc_label));

	*new_heredoc_label = *heredoc_label;
	new_heredoc_label->label = estrndup(heredoc_label->label, heredoc_label->length);

	zend_ptr_stack_push(&SCNG(heredoc_label_stack), (void *) new_heredoc_label);
}

/* Check that { }, [ ], ( ) are nested correctly */
static void report_bad_nesting(char opening, int opening_lineno, char closing)
{
	char   buf[256];
	size_t used = 0;

	used = snprintf(buf, sizeof(buf), "Unclosed '%c'", opening);

	if (opening_lineno != CG(zend_lineno)) {
		used += snprintf(buf + used, sizeof(buf) - used, " on line %d", opening_lineno);
	}

	if (closing) { 	/* 'closing' will be 0 if at end of file */
		used += snprintf(buf + used, sizeof(buf) - used, " does not match '%c'", closing);
	}

	zend_throw_exception(zend_ce_parse_error, buf, 0);
}

static void enter_nesting(char opening)
{
	zend_nest_location nest_loc = {opening, CG(zend_lineno)};
	zend_stack_push(&SCNG(nest_location_stack), &nest_loc);
}

static zend_result exit_nesting(char closing)
{
	if (zend_stack_is_empty(&SCNG(nest_location_stack))) {
		zend_throw_exception_ex(zend_ce_parse_error, 0, "Unmatched '%c'", closing);
		return FAILURE;
	}

	zend_nest_location *nest_loc = zend_stack_top(&SCNG(nest_location_stack));
	char opening = nest_loc->text;

	if ((opening == '{' && closing != '}') ||
	    (opening == '[' && closing != ']') ||
	    (opening == '(' && closing != ')')) {
		report_bad_nesting(opening, nest_loc->lineno, closing);
		return FAILURE;
	}

	zend_stack_del_top(&SCNG(nest_location_stack));
	return SUCCESS;
}

static zend_result check_nesting_at_end(void)
{
	if (!zend_stack_is_empty(&SCNG(nest_location_stack))) {
		zend_nest_location *nest_loc = zend_stack_top(&SCNG(nest_location_stack));
		report_bad_nesting(nest_loc->text, nest_loc->lineno, 0);
		return FAILURE;
	}

	return SUCCESS;
}

#define PARSER_MODE() \
	EXPECTED(elem != NULL)

#define RETURN_TOKEN(_token) do { \
		token = _token; \
		goto emit_token; \
	} while (0)

#define RETURN_TOKEN_WITH_VAL(_token) do { \
		token = _token; \
		goto emit_token_with_val; \
	} while (0)

#define RETURN_TOKEN_WITH_STR(_token, _offset) do { \
		token = _token; \
		offset = _offset; \
		goto emit_token_with_str; \
	} while (0)

#define RETURN_TOKEN_WITH_IDENT(_token) do { \
		token = _token; \
		goto emit_token_with_ident; \
	} while (0)

#define RETURN_OR_SKIP_TOKEN(_token) do { \
		token = _token; \
		if (PARSER_MODE()) { \
			goto skip_token; \
		} \
		goto emit_token; \
	} while (0)

#define RETURN_EXIT_NESTING_TOKEN(_token) do { \
		if (exit_nesting(_token) && PARSER_MODE()) { \
			RETURN_TOKEN(T_ERROR); \
		} else { \
			RETURN_TOKEN(_token); \
		} \
	} while(0)

#define RETURN_END_TOKEN do { \
		if (check_nesting_at_end() && PARSER_MODE()) { \
			RETURN_TOKEN(T_ERROR); \
		} else { \
			RETURN_TOKEN(END); \
		} \
	} while (0)

int ZEND_FASTCALL lex_scan(zval *zendlval, zend_parser_stack_elem *elem)
{
int token;
int offset;
int start_line = CG(zend_lineno);

	ZVAL_UNDEF(zendlval);
restart:
	SCNG(yy_text) = YYCURSOR;


{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if (YYGETCONDITION() < 5) {
		if (YYGETCONDITION() < 2) {
			if (YYGETCONDITION() < 1) {
				goto yyc_ST_IN_SCRIPTING;
			} else {
				goto yyc_ST_LOOKING_FOR_PROPERTY;
			}
		} else {
			if (YYGETCONDITION() < 3) {
				goto yyc_ST_BACKQUOTE;
			} else {
				if (YYGETCONDITION() < 4) {
					goto yyc_ST_DOUBLE_QUOTES;
				} else {
					goto yyc_ST_HEREDOC;
				}
			}
		}
	} else {
		if (YYGETCONDITION() < 8) {
			if (YYGETCONDITION() < 6) {
				goto yyc_ST_LOOKING_FOR_VARNAME;
			} else {
				if (YYGETCONDITION() < 7) {
					goto yyc_ST_VAR_OFFSET;
				} else {
					goto yyc_SHEBANG;
				}
			}
		} else {
			if (YYGETCONDITION() < 9) {
				goto yyc_INITIAL;
			} else {
				if (YYGETCONDITION() < 10) {
					goto yyc_ST_END_HEREDOC;
				} else {
					goto yyc_ST_NOWDOC;
				}
			}
		}
	}
/* *********************************** */
yyc_INITIAL:
	YYDEBUG(1, *YYCURSOR);
	YYFILL(7);
	yych = *YYCURSOR;
	if (yych != '<') goto yy5;
	YYDEBUG(3, *YYCURSOR);
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '?') goto yy6;
yy4:
	YYDEBUG(4, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

inline_char_handler:

	while (1) {
		YYCTYPE *ptr = memchr(YYCURSOR, '<', YYLIMIT - YYCURSOR);

		YYCURSOR = ptr ? ptr + 1 : YYLIMIT;

		if (YYCURSOR >= YYLIMIT) {
			break;
		}

		if (*YYCURSOR == '?') {
			if (CG(short_tags) /* <? */
				|| (*(YYCURSOR + 1) == '=') /* <?= */
				|| (!strncasecmp((char*)YYCURSOR + 1, "php", 3) && /* <?php[ \t\r\n] */
					(YYCURSOR + 4 == YYLIMIT ||
					YYCURSOR[4] == ' ' || YYCURSOR[4] == '\t' ||
					YYCURSOR[4] == '\n' || YYCURSOR[4] == '\r'))
			) {
				YYCURSOR--;
				break;
			}
		}
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	if (SCNG(output_filter)) {
		size_t readsize;
		char *s = NULL;
		size_t sz = 0;
		// TODO: avoid reallocation ???
		readsize = SCNG(output_filter)((unsigned char **)&s, &sz, (unsigned char *)yytext, (size_t)yyleng);
		ZVAL_STRINGL(zendlval, s, sz);
		efree(s);
		if (readsize < yyleng) {
			yyless(readsize);
		}
	} else if (yyleng == 1) {
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*yytext));
	} else {
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	HANDLE_NEWLINES(yytext, yyleng);
	RETURN_TOKEN_WITH_VAL(T_INLINE_HTML);
}
yy5:
	YYDEBUG(5, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy4;
yy6:
	YYDEBUG(6, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'O') {
		if (yych == '=') goto yy8;
	} else {
		if (yych <= 'P') goto yy10;
		if (yych == 'p') goto yy10;
	}
yy7:
	YYDEBUG(7, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	if (CG(short_tags)) {
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	} else {
		goto inline_char_handler;
	}
}
yy8:
	YYDEBUG(8, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(9, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	BEGIN(ST_IN_SCRIPTING);
	if (PARSER_MODE()) {
		/* We'll reject this as an identifier in zend_lex_tstring. */
		RETURN_TOKEN_WITH_IDENT(T_ECHO);
	}
	RETURN_TOKEN(T_OPEN_TAG_WITH_ECHO);
}
yy10:
	YYDEBUG(10, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych == 'H') goto yy12;
	if (yych == 'h') goto yy12;
yy11:
	YYDEBUG(11, *YYCURSOR);
	YYCURSOR = YYMARKER;
	goto yy7;
yy12:
	YYDEBUG(12, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych == 'P') goto yy13;
	if (yych != 'p') goto yy11;
yy13:
	YYDEBUG(13, *YYCURSOR);
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '\f') {
		if (yych <= 0x08) goto yy14;
		if (yych <= '\n') goto yy15;
	} else {
		if (yych <= '\r') goto yy17;
		if (yych == ' ') goto yy15;
	}
yy14:
	YYDEBUG(14, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	/* Allow <?php followed by end of file. */
	if (YYCURSOR == YYLIMIT) {
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	}
	/* Degenerate case: <?phpX is interpreted as <? phpX with short tags. */
	if (CG(short_tags)) {
		yyless(2);
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	}
	goto inline_char_handler;
}
yy15:
	YYDEBUG(15, *YYCURSOR);
	++YYCURSOR;
yy16:
	YYDEBUG(16, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	HANDLE_NEWLINE(yytext[yyleng-1]);
	BEGIN(ST_IN_SCRIPTING);
	RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
}
yy17:
	YYDEBUG(17, *YYCURSOR);
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '\n') goto yy15;
	goto yy16;
/* *********************************** */
yyc_SHEBANG:
	{
		static const unsigned char yybm[] = {
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,   0,  64,  64, 128,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
		};
		YYDEBUG(18, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych != '#') goto yy22;
		YYDEBUG(20, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '!') goto yy23;
yy21:
		YYDEBUG(21, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(0);
	BEGIN(INITIAL);
	goto restart;
}
yy22:
		YYDEBUG(22, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy21;
yy23:
		YYDEBUG(23, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(24, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy23;
		}
		if (yych <= '\n') goto yy28;
yy25:
		YYDEBUG(25, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(26, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy23;
		}
		if (yych <= '\n') goto yy28;
		goto yy25;
yy27:
		YYDEBUG(27, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	CG(zend_lineno)++;
	BEGIN(INITIAL);
	goto restart;
}
yy28:
		YYDEBUG(28, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy27;
	}
/* *********************************** */
yyc_ST_BACKQUOTE:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(29, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych != '$') goto yy36;
		} else {
			if (yych <= '`') goto yy34;
			if (yych == '{') goto yy33;
			goto yy36;
		}
		YYDEBUG(31, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy32;
			if (yych <= 'Z') goto yy39;
			if (yych >= '_') goto yy39;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy39;
			} else {
				if (yych <= '{') goto yy42;
				if (yych >= 0x80) goto yy39;
			}
		}
yy32:
		YYDEBUG(32, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '`':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	if (EXPECTED(zend_scan_escape_string(zendlval, yytext, yyleng, '`') == SUCCESS)
	 || !PARSER_MODE()) {
		RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
	} else {
		RETURN_TOKEN(T_ERROR);
	}
}
yy33:
		YYDEBUG(33, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy37;
		goto yy32;
yy34:
		YYDEBUG(34, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(35, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN('`');
}
yy36:
		YYDEBUG(36, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy32;
yy37:
		YYDEBUG(37, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(38, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
yy39:
		YYDEBUG(39, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(40, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy39;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy44;
		} else {
			if (yych <= '?') goto yy46;
			if (yych <= '@') goto yy41;
			if (yych <= '[') goto yy47;
		}
yy41:
		YYDEBUG(41, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy42:
		YYDEBUG(42, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(43, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
yy44:
		YYDEBUG(44, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy53;
yy45:
		YYDEBUG(45, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy41;
yy46:
		YYDEBUG(46, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy49;
		goto yy45;
yy47:
		YYDEBUG(47, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(48, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy49:
		YYDEBUG(49, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy45;
		YYDEBUG(50, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy45;
			if (yych <= 'Z') goto yy51;
			if (yych <= '^') goto yy45;
		} else {
			if (yych <= '`') goto yy45;
			if (yych <= 'z') goto yy51;
			if (yych <= 0x7F) goto yy45;
		}
yy51:
		YYDEBUG(51, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(52, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy53:
		YYDEBUG(53, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy45;
			if (yych <= 'Z') goto yy54;
			if (yych <= '^') goto yy45;
		} else {
			if (yych <= '`') goto yy45;
			if (yych <= 'z') goto yy54;
			if (yych <= 0x7F) goto yy45;
		}
yy54:
		YYDEBUG(54, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(55, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
	}
/* *********************************** */
yyc_ST_DOUBLE_QUOTES:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(56, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '#') {
			if (yych == '"') goto yy61;
			goto yy63;
		} else {
			if (yych <= '$') goto yy58;
			if (yych == '{') goto yy60;
			goto yy63;
		}
yy58:
		YYDEBUG(58, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy59;
			if (yych <= 'Z') goto yy66;
			if (yych >= '_') goto yy66;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy66;
			} else {
				if (yych <= '{') goto yy69;
				if (yych >= 0x80) goto yy66;
			}
		}
yy59:
		YYDEBUG(59, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (GET_DOUBLE_QUOTES_SCANNED_LENGTH()) {
		YYCURSOR += GET_DOUBLE_QUOTES_SCANNED_LENGTH() - 1;
		SET_DOUBLE_QUOTES_SCANNED_LENGTH(0);

		goto double_quotes_scan_done;
	}

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

double_quotes_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);

	if (EXPECTED(zend_scan_escape_string(zendlval, yytext, yyleng, '"') == SUCCESS)
	 || !PARSER_MODE()) {
		RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
	} else {
		RETURN_TOKEN(T_ERROR);
	}
}
yy60:
		YYDEBUG(60, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy64;
		goto yy59;
yy61:
		YYDEBUG(61, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(62, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN('"');
}
yy63:
		YYDEBUG(63, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy59;
yy64:
		YYDEBUG(64, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(65, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
yy66:
		YYDEBUG(66, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(67, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy66;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy71;
		} else {
			if (yych <= '?') goto yy73;
			if (yych <= '@') goto yy68;
			if (yych <= '[') goto yy74;
		}
yy68:
		YYDEBUG(68, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy69:
		YYDEBUG(69, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(70, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
yy71:
		YYDEBUG(71, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy80;
yy72:
		YYDEBUG(72, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy68;
yy73:
		YYDEBUG(73, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy76;
		goto yy72;
yy74:
		YYDEBUG(74, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(75, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy76:
		YYDEBUG(76, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy72;
		YYDEBUG(77, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy72;
			if (yych <= 'Z') goto yy78;
			if (yych <= '^') goto yy72;
		} else {
			if (yych <= '`') goto yy72;
			if (yych <= 'z') goto yy78;
			if (yych <= 0x7F) goto yy72;
		}
yy78:
		YYDEBUG(78, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(79, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy80:
		YYDEBUG(80, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy72;
			if (yych <= 'Z') goto yy81;
			if (yych <= '^') goto yy72;
		} else {
			if (yych <= '`') goto yy72;
			if (yych <= 'z') goto yy81;
			if (yych <= 0x7F) goto yy72;
		}
yy81:
		YYDEBUG(81, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(82, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
	}
/* *********************************** */
yyc_ST_END_HEREDOC:
	YYDEBUG(83, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(85, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(86, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_pop(&SCNG(heredoc_label_stack));

	yyleng = heredoc_label->indentation + heredoc_label->length;
	YYCURSOR += yyleng - 1;

	heredoc_label_dtor(heredoc_label);
	efree(heredoc_label);

	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN(T_END_HEREDOC);
}
/* *********************************** */
yyc_ST_HEREDOC:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(87, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych == '$') goto yy89;
		if (yych == '{') goto yy91;
		goto yy92;
yy89:
		YYDEBUG(89, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy90;
			if (yych <= 'Z') goto yy95;
			if (yych >= '_') goto yy95;
		} else {
			if (yych <= 'z') {
				if (yych >= 'a') goto yy95;
			} else {
				if (yych <= '{') goto yy98;
				if (yych >= 0x80) goto yy95;
			}
		}
yy90:
		YYDEBUG(90, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_top(&SCNG(heredoc_label_stack));
	int newline = 0, indentation = 0, spacing = 0;

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			case '\n':
				indentation = spacing = 0;

				while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
					if (*YYCURSOR == '\t') {
						spacing |= HEREDOC_USING_TABS;
					} else {
						spacing |= HEREDOC_USING_SPACES;
					}
					++YYCURSOR;
					++indentation;
				}

				if (YYCURSOR == YYLIMIT) {
					yyleng = YYCURSOR - SCNG(yy_text);
					HANDLE_NEWLINES(yytext, yyleng);
					ZVAL_NULL(zendlval);
					RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
				}

				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, heredoc_label->label, heredoc_label->length)) {
					if (IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
						continue;
					}

					if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
						zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
						if (PARSER_MODE()) {
							RETURN_TOKEN(T_ERROR);
						}
					}

					/* newline before label will be subtracted from returned text, but
					 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
					if (YYCURSOR[-indentation - 2] == '\r' && YYCURSOR[-indentation - 1] == '\n') {
						newline = 2; /* Windows newline */
					} else {
						newline = 1;
					}

					CG(increment_lineno) = 1; /* For newline before label */

					if (SCNG(heredoc_scan_ahead)) {
						SCNG(heredoc_indentation) = indentation;
						SCNG(heredoc_indentation_uses_spaces) = (spacing == HEREDOC_USING_SPACES);
					} else {
						YYCURSOR -= indentation;
					}

					BEGIN(ST_END_HEREDOC);

					goto heredoc_scan_done;
				}
				continue;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT && *YYCURSOR != '\n' && *YYCURSOR != '\r') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

heredoc_scan_done:

	yyleng = YYCURSOR - SCNG(yy_text);
	ZVAL_STRINGL(zendlval, yytext, yyleng - newline);

	if (!SCNG(heredoc_scan_ahead) && !EG(exception) && PARSER_MODE()) {
		bool newline_at_start = *(yytext - 1) == '\n' || *(yytext - 1) == '\r';
		zend_string *copy = Z_STR_P(zendlval);

		if (!strip_multiline_string_indentation(
				zendlval, heredoc_label->indentation, heredoc_label->indentation_uses_spaces,
				newline_at_start, newline != 0)) {
			RETURN_TOKEN(T_ERROR);
		}

		if (UNEXPECTED(zend_scan_escape_string(zendlval, ZSTR_VAL(copy), ZSTR_LEN(copy), 0) != SUCCESS)) {
			zend_string_efree(copy);
			RETURN_TOKEN(T_ERROR);
		}

		zend_string_efree(copy);
	} else {
		HANDLE_NEWLINES(yytext, yyleng - newline);
	}

	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
yy91:
		YYDEBUG(91, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy93;
		goto yy90;
yy92:
		YYDEBUG(92, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy90;
yy93:
		YYDEBUG(93, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(94, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
yy95:
		YYDEBUG(95, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(96, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy95;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy100;
		} else {
			if (yych <= '?') goto yy102;
			if (yych <= '@') goto yy97;
			if (yych <= '[') goto yy103;
		}
yy97:
		YYDEBUG(97, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy98:
		YYDEBUG(98, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(99, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
yy100:
		YYDEBUG(100, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy109;
yy101:
		YYDEBUG(101, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy97;
yy102:
		YYDEBUG(102, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy105;
		goto yy101;
yy103:
		YYDEBUG(103, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(104, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy105:
		YYDEBUG(105, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy101;
		YYDEBUG(106, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy101;
			if (yych <= 'Z') goto yy107;
			if (yych <= '^') goto yy101;
		} else {
			if (yych <= '`') goto yy101;
			if (yych <= 'z') goto yy107;
			if (yych <= 0x7F) goto yy101;
		}
yy107:
		YYDEBUG(107, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(108, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy109:
		YYDEBUG(109, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy101;
			if (yych <= 'Z') goto yy110;
			if (yych <= '^') goto yy101;
		} else {
			if (yych <= '`') goto yy101;
			if (yych <= 'z') goto yy110;
			if (yych <= 0x7F) goto yy101;
		}
yy110:
		YYDEBUG(110, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(111, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
	}
/* *********************************** */
yyc_ST_IN_SCRIPTING:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 192,  64,   0,   0,  64,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			192,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 62,  62,  54,  54,  54,  54,  54,  54, 
			 38,  38,   0,   0,   0,   0,   0,   0, 
			  0,  34,  34,  34,  34,  34,  34,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   0,   0,   0,   0,   2, 
			  0,  34,  34,  34,  34,  34,  34,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   0,   0,   0,   0,   0, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
			  2,   2,   2,   2,   2,   2,   2,   2, 
		};
		YYDEBUG(112, *YYCURSOR);
		YYFILL(16);
		yych = *YYCURSOR;
		YYDEBUG(-1, yych);
		switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\v':
		case '\f':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x1F:
		case 0x7F:	goto yy180;
		case '\t':
		case '\n':
		case '\r':
		case ' ':	goto yy135;
		case '!':	goto yy148;
		case '"':	goto yy176;
		case '#':	goto yy120;
		case '$':	goto yy162;
		case '%':	goto yy153;
		case '&':	goto yy154;
		case '\'':	goto yy174;
		case '(':	goto yy141;
		case ')':
		case ']':	goto yy159;
		case '*':	goto yy151;
		case '+':	goto yy147;
		case ',':
		case ';':
		case '@':
		case '~':	goto yy163;
		case '-':	goto yy132;
		case '.':	goto yy138;
		case '/':	goto yy152;
		case '0':	goto yy168;
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':	goto yy170;
		case ':':	goto yy137;
		case '<':	goto yy149;
		case '=':	goto yy145;
		case '>':	goto yy150;
		case '?':	goto yy134;
		case 'A':
		case 'a':	goto yy126;
		case 'B':
		case 'b':	goto yy129;
		case 'C':
		case 'c':	goto yy118;
		case 'D':
		case 'd':	goto yy116;
		case 'E':
		case 'e':	goto yy114;
		case 'F':
		case 'f':	goto yy117;
		case 'G':
		case 'g':	goto yy130;
		case 'I':
		case 'i':	goto yy124;
		case 'L':
		case 'l':	goto yy146;
		case 'M':
		case 'm':	goto yy128;
		case 'N':
		case 'n':	goto yy139;
		case 'O':
		case 'o':	goto yy157;
		case 'P':
		case 'p':	goto yy131;
		case 'R':
		case 'r':	goto yy119;
		case 'S':
		case 's':	goto yy127;
		case 'T':
		case 't':	goto yy123;
		case 'U':
		case 'u':	goto yy143;
		case 'V':
		case 'v':	goto yy140;
		case 'W':
		case 'w':	goto yy125;
		case 'X':
		case 'x':	goto yy158;
		case 'Y':
		case 'y':	goto yy122;
		case '[':	goto yy161;
		case '\\':	goto yy172;
		case '^':	goto yy156;
		case '_':	goto yy144;
		case '`':	goto yy178;
		case '{':	goto yy164;
		case '|':	goto yy155;
		case '}':	goto yy166;
		default:	goto yy171;
		}
yy114:
		YYDEBUG(114, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'C':
		case 'c':	goto yy796;
		case 'L':
		case 'l':	goto yy797;
		case 'M':
		case 'm':	goto yy798;
		case 'N':
		case 'n':	goto yy799;
		case 'V':
		case 'v':	goto yy800;
		case 'X':
		case 'x':	goto yy801;
		default:	goto yy190;
		}
yy115:
		YYDEBUG(115, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy116:
		YYDEBUG(116, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych <= 'H') {
				if (yych == 'E') goto yy778;
				goto yy190;
			} else {
				if (yych <= 'I') goto yy779;
				if (yych <= 'N') goto yy190;
				goto yy780;
			}
		} else {
			if (yych <= 'h') {
				if (yych == 'e') goto yy778;
				goto yy190;
			} else {
				if (yych <= 'i') goto yy779;
				if (yych == 'o') goto yy780;
				goto yy190;
			}
		}
yy117:
		YYDEBUG(117, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych <= 'M') {
				if (yych == 'I') goto yy752;
				goto yy190;
			} else {
				if (yych <= 'N') goto yy753;
				if (yych <= 'O') goto yy755;
				if (yych <= 'T') goto yy190;
				goto yy756;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'i') goto yy752;
				if (yych <= 'm') goto yy190;
				goto yy753;
			} else {
				if (yych <= 'o') goto yy755;
				if (yych == 'u') goto yy756;
				goto yy190;
			}
		}
yy118:
		YYDEBUG(118, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych <= 'K') {
				if (yych == 'A') goto yy717;
				goto yy190;
			} else {
				if (yych <= 'L') goto yy718;
				if (yych <= 'N') goto yy190;
				goto yy719;
			}
		} else {
			if (yych <= 'k') {
				if (yych == 'a') goto yy717;
				goto yy190;
			} else {
				if (yych <= 'l') goto yy718;
				if (yych == 'o') goto yy719;
				goto yy190;
			}
		}
yy119:
		YYDEBUG(119, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy699;
		if (yych == 'e') goto yy699;
		goto yy190;
yy120:
		YYDEBUG(120, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '[') goto yy697;
yy121:
		YYDEBUG(121, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
			case '\n':
				YYCURSOR--;
				break;
			case '?':
				if (*YYCURSOR == '>') {
					YYCURSOR--;
					break;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);
	RETURN_OR_SKIP_TOKEN(T_COMMENT);
}
yy122:
		YYDEBUG(122, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy684;
		if (yych == 'i') goto yy684;
		goto yy190;
yy123:
		YYDEBUG(123, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'R') {
			if (yych == 'H') goto yy672;
			if (yych <= 'Q') goto yy190;
			goto yy673;
		} else {
			if (yych <= 'h') {
				if (yych <= 'g') goto yy190;
				goto yy672;
			} else {
				if (yych == 'r') goto yy673;
				goto yy190;
			}
		}
yy124:
		YYDEBUG(124, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'L') {
				if (yych == 'F') goto yy619;
				goto yy190;
			} else {
				if (yych <= 'M') goto yy621;
				if (yych <= 'N') goto yy622;
				if (yych <= 'R') goto yy190;
				goto yy623;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'f') goto yy619;
				if (yych <= 'l') goto yy190;
				goto yy621;
			} else {
				if (yych <= 'n') goto yy622;
				if (yych == 's') goto yy623;
				goto yy190;
			}
		}
yy125:
		YYDEBUG(125, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy614;
		if (yych == 'h') goto yy614;
		goto yy190;
yy126:
		YYDEBUG(126, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'M') {
				if (yych == 'B') goto yy596;
				goto yy190;
			} else {
				if (yych <= 'N') goto yy597;
				if (yych <= 'Q') goto yy190;
				if (yych <= 'R') goto yy598;
				goto yy599;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy596;
				if (yych <= 'm') goto yy190;
				goto yy597;
			} else {
				if (yych <= 'q') goto yy190;
				if (yych <= 'r') goto yy598;
				if (yych <= 's') goto yy599;
				goto yy190;
			}
		}
yy127:
		YYDEBUG(127, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'W') {
			if (yych == 'T') goto yy584;
			if (yych <= 'V') goto yy190;
			goto yy585;
		} else {
			if (yych <= 't') {
				if (yych <= 's') goto yy190;
				goto yy584;
			} else {
				if (yych == 'w') goto yy585;
				goto yy190;
			}
		}
yy128:
		YYDEBUG(128, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy579;
		if (yych == 'a') goto yy579;
		goto yy190;
yy129:
		YYDEBUG(129, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') {
			if (yych <= '"') {
				if (yych <= '!') goto yy190;
				goto yy571;
			} else {
				if (yych == '\'') goto yy572;
				goto yy190;
			}
		} else {
			if (yych <= 'R') {
				if (yych <= '<') goto yy570;
				if (yych <= 'Q') goto yy190;
				goto yy573;
			} else {
				if (yych == 'r') goto yy573;
				goto yy190;
			}
		}
yy130:
		YYDEBUG(130, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'L') goto yy560;
			if (yych <= 'N') goto yy190;
			goto yy561;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy190;
				goto yy560;
			} else {
				if (yych == 'o') goto yy561;
				goto yy190;
			}
		}
yy131:
		YYDEBUG(131, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'R') goto yy536;
			if (yych <= 'T') goto yy190;
			goto yy537;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy190;
				goto yy536;
			} else {
				if (yych == 'u') goto yy537;
				goto yy190;
			}
		}
yy132:
		YYDEBUG(132, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '<') {
			if (yych == '-') goto yy532;
		} else {
			if (yych <= '=') goto yy530;
			if (yych <= '>') goto yy534;
		}
yy133:
		YYDEBUG(133, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(yytext[0]);
}
yy134:
		YYDEBUG(134, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '=') {
			if (yych == '-') goto yy523;
			goto yy133;
		} else {
			if (yych <= '>') goto yy519;
			if (yych <= '?') goto yy521;
			goto yy133;
		}
yy135:
		YYDEBUG(135, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy518;
yy136:
		YYDEBUG(136, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	goto return_whitespace;
}
yy137:
		YYDEBUG(137, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == ':') goto yy515;
		goto yy133;
yy138:
		YYDEBUG(138, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '/') {
			if (yych == '.') goto yy509;
			goto yy133;
		} else {
			if (yych <= '9') goto yy505;
			if (yych == '=') goto yy507;
			goto yy133;
		}
yy139:
		YYDEBUG(139, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych == 'A') goto yy489;
			if (yych <= 'D') goto yy190;
			goto yy490;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy190;
				goto yy489;
			} else {
				if (yych == 'e') goto yy490;
				goto yy190;
			}
		}
yy140:
		YYDEBUG(140, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy486;
		if (yych == 'a') goto yy486;
		goto yy190;
yy141:
		YYDEBUG(141, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy407;
					if (yych >= ' ') goto yy407;
				} else {
					if (yych <= '@') goto yy142;
					if (yych != 'C') goto yy407;
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy407;
					if (yych >= 'I') goto yy407;
				} else {
					if (yych == 'O') goto yy407;
					if (yych >= 'R') goto yy407;
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'b') {
					if (yych == 'U') goto yy407;
					if (yych >= 'a') goto yy407;
				} else {
					if (yych == 'd') goto yy407;
					if (yych >= 'f') goto yy407;
				}
			} else {
				if (yych <= 'o') {
					if (yych == 'i') goto yy407;
					if (yych >= 'o') goto yy407;
				} else {
					if (yych <= 's') {
						if (yych >= 'r') goto yy407;
					} else {
						if (yych == 'u') goto yy407;
					}
				}
			}
		}
yy142:
		YYDEBUG(142, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	enter_nesting(yytext[0]);
	RETURN_TOKEN(yytext[0]);
}
yy143:
		YYDEBUG(143, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych == 'N') goto yy398;
			if (yych <= 'R') goto yy190;
			goto yy399;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy190;
				goto yy398;
			} else {
				if (yych == 's') goto yy399;
				goto yy190;
			}
		}
yy144:
		YYDEBUG(144, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy316;
		goto yy190;
yy145:
		YYDEBUG(145, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy133;
		if (yych <= '=') goto yy310;
		if (yych <= '>') goto yy312;
		goto yy133;
yy146:
		YYDEBUG(146, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy306;
		if (yych == 'i') goto yy306;
		goto yy190;
yy147:
		YYDEBUG(147, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '+') goto yy304;
		if (yych == '=') goto yy302;
		goto yy133;
yy148:
		YYDEBUG(148, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy299;
		goto yy133;
yy149:
		YYDEBUG(149, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ';') goto yy133;
		if (yych <= '<') goto yy275;
		if (yych <= '=') goto yy277;
		if (yych <= '>') goto yy279;
		goto yy133;
yy150:
		YYDEBUG(150, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy133;
		if (yych <= '=') goto yy271;
		if (yych <= '>') goto yy269;
		goto yy133;
yy151:
		YYDEBUG(151, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '*') goto yy263;
		if (yych == '=') goto yy265;
		goto yy133;
yy152:
		YYDEBUG(152, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '.') {
			if (yych == '*') goto yy255;
			goto yy133;
		} else {
			if (yych <= '/') goto yy257;
			if (yych == '=') goto yy258;
			goto yy133;
		}
yy153:
		YYDEBUG(153, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy253;
		goto yy133;
yy154:
		YYDEBUG(154, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '&') goto yy249;
		if (yych == '=') goto yy251;
		goto yy133;
yy155:
		YYDEBUG(155, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy247;
		if (yych == '|') goto yy245;
		goto yy133;
yy156:
		YYDEBUG(156, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy243;
		goto yy133;
yy157:
		YYDEBUG(157, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy241;
		if (yych == 'r') goto yy241;
		goto yy190;
yy158:
		YYDEBUG(158, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy238;
		if (yych == 'o') goto yy238;
		goto yy190;
yy159:
		YYDEBUG(159, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(160, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* Check that ] and ) match up properly with a preceding [ or ( */
	RETURN_EXIT_NESTING_TOKEN(yytext[0]);
}
yy161:
		YYDEBUG(161, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy142;
yy162:
		YYDEBUG(162, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy133;
			if (yych <= 'Z') goto yy235;
			if (yych <= '^') goto yy133;
			goto yy235;
		} else {
			if (yych <= '`') goto yy133;
			if (yych <= 'z') goto yy235;
			if (yych <= 0x7F) goto yy133;
			goto yy235;
		}
yy163:
		YYDEBUG(163, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy133;
yy164:
		YYDEBUG(164, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(165, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_IN_SCRIPTING);
	enter_nesting('{');
	RETURN_TOKEN('{');
}
yy166:
		YYDEBUG(166, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(167, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RESET_DOC_COMMENT();
	if (!zend_stack_is_empty(&SCNG(state_stack))) {
		yy_pop_state();
	}
	RETURN_EXIT_NESTING_TOKEN('}');
}
yy168:
		YYDEBUG(168, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'X') {
			if (yych <= 'N') {
				if (yych == 'B') goto yy216;
				goto yy199;
			} else {
				if (yych <= 'O') goto yy215;
				if (yych <= 'W') goto yy199;
				goto yy214;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy216;
				goto yy199;
			} else {
				if (yych <= 'o') goto yy215;
				if (yych == 'x') goto yy214;
				goto yy199;
			}
		}
yy169:
		YYDEBUG(169, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	size_t len = yyleng;
	char *end, *lnum = yytext;
	bool is_octal = lnum[0] == '0';
	bool contains_underscores = (memchr(lnum, '_', len) != NULL);

	if (contains_underscores) {
		lnum = estrndup(lnum, len);
		strip_underscores(lnum, &len);
	}

	/* Digits 8 and 9 are illegal in octal literals. */
	if (is_octal) {
		size_t i;
		for (i = 0; i < len; i++) {
			if (lnum[i] == '8' || lnum[i] == '9') {
				zend_throw_exception(zend_ce_parse_error, "Invalid numeric literal", 0);
				if (PARSER_MODE()) {
					if (contains_underscores) {
						efree(lnum);
					}
					ZVAL_UNDEF(zendlval);
					RETURN_TOKEN(T_ERROR);
				}

				/* Continue in order to determine if this is T_LNUMBER or T_DNUMBER. */
				len = i;
				break;
			}
		}
	}


	if (len < MAX_LENGTH_OF_LONG - 1) { /* Won't overflow */
		errno = 0;
		/* base must be passed explicitly for correct parse error on Windows */
		ZVAL_LONG(zendlval, ZEND_STRTOL(lnum, &end, is_octal ? 8 : 10));
		ZEND_ASSERT(end == lnum + len);
	} else {
		errno = 0;
		ZVAL_LONG(zendlval, ZEND_STRTOL(lnum, &end, 0));
		if (errno == ERANGE) { /* Overflow */
			errno = 0;
			if (is_octal) { /* octal overflow */
				ZVAL_DOUBLE(zendlval, zend_oct_strtod(lnum, (const char **)&end));
			} else {
				ZVAL_DOUBLE(zendlval, zend_strtod(lnum, (const char **)&end));
			}
			ZEND_ASSERT(end == lnum + len);
			if (contains_underscores) {
				efree(lnum);
			}
			RETURN_TOKEN_WITH_VAL(T_DNUMBER);
		}
		ZEND_ASSERT(end == lnum + len);
	}
	ZEND_ASSERT(!errno);
	if (contains_underscores) {
		efree(lnum);
	}
	RETURN_TOKEN_WITH_VAL(T_LNUMBER);
}
yy170:
		YYDEBUG(170, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy199;
yy171:
		YYDEBUG(171, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy190;
yy172:
		YYDEBUG(172, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy173;
			if (yych <= 'Z') goto yy182;
			if (yych >= '_') goto yy182;
		} else {
			if (yych <= '`') goto yy173;
			if (yych <= 'z') goto yy182;
			if (yych >= 0x80) goto yy182;
		}
yy173:
		YYDEBUG(173, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_NS_SEPARATOR);
}
yy174:
		YYDEBUG(174, *YYCURSOR);
		++YYCURSOR;
yy175:
		YYDEBUG(175, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	char *s, *t;
	char *end;
	int bprefix = (yytext[0] != '\'') ? 1 : 0;

	while (1) {
		if (YYCURSOR < YYLIMIT) {
			if (*YYCURSOR == '\'') {
				YYCURSOR++;
				yyleng = YYCURSOR - SCNG(yy_text);

				break;
			} else if (*YYCURSOR++ == '\\' && YYCURSOR < YYLIMIT) {
				YYCURSOR++;
			}
		} else {
			yyleng = YYLIMIT - SCNG(yy_text);

			/* Unclosed single quotes; treat similar to double quotes, but without a separate token
			 * for ' (unrecognized by parser), instead of old flex fallback to "Unexpected character..."
			 * rule, which continued in ST_IN_SCRIPTING state after the quote */
			ZVAL_NULL(zendlval);
			RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
		}
	}

	if (yyleng-bprefix-2 <= 1) {
		if (yyleng-bprefix-2 < 1) {
			ZVAL_EMPTY_STRING(zendlval);
		} else {
			zend_uchar c = (zend_uchar)*(yytext+bprefix+1);
			if (c == '\n' || c == '\r') {
				CG(zend_lineno)++;
			}
			ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR(c));
		}
		goto skip_escape_conversion;
	}
	ZVAL_STRINGL(zendlval, yytext+bprefix+1, yyleng-bprefix-2);

	/* convert escape sequences */
	s = Z_STRVAL_P(zendlval);
	end = s+Z_STRLEN_P(zendlval);
	while (1) {
		if (UNEXPECTED(*s=='\\')) {
			break;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
		if (s == end) {
			goto skip_escape_conversion;
		}
	}

	t = s;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (*s == '\\' || *s == '\'') {
				*t++ = *s;
			} else {
				*t++ = '\\';
				*t++ = *s;
			}
		} else {
			*t++ = *s;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
	Z_STRLEN_P(zendlval) = t - Z_STRVAL_P(zendlval);

skip_escape_conversion:
	if (SCNG(output_filter)) {
		size_t sz = 0;
		char *str = NULL;
		zend_string *new_str;
		s = Z_STRVAL_P(zendlval);
		// TODO: avoid reallocation ???
		SCNG(output_filter)((unsigned char **)&str, &sz, (unsigned char *)s, (size_t)Z_STRLEN_P(zendlval));
		new_str = zend_string_init(str, sz, 0);
		if (str != s) {
			efree(str);
		}
		zend_string_release_ex(Z_STR_P(zendlval), 0);
		ZVAL_STR(zendlval, new_str);
	}
	RETURN_TOKEN_WITH_VAL(T_CONSTANT_ENCAPSED_STRING);
}
yy176:
		YYDEBUG(176, *YYCURSOR);
		++YYCURSOR;
yy177:
		YYDEBUG(177, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	int bprefix = (yytext[0] != '"') ? 1 : 0;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				yyleng = YYCURSOR - SCNG(yy_text);
				if (EXPECTED(zend_scan_escape_string(zendlval, yytext+bprefix+1, yyleng-bprefix-2, '"') == SUCCESS)
				 || !PARSER_MODE()) {
					RETURN_TOKEN_WITH_VAL(T_CONSTANT_ENCAPSED_STRING);
				} else {
					RETURN_TOKEN(T_ERROR);
				}
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	/* Remember how much was scanned to save rescanning */
	SET_DOUBLE_QUOTES_SCANNED_LENGTH(YYCURSOR - SCNG(yy_text) - yyleng);

	YYCURSOR = SCNG(yy_text) + yyleng;

	BEGIN(ST_DOUBLE_QUOTES);
	RETURN_TOKEN('"');
}
yy178:
		YYDEBUG(178, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(179, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(ST_BACKQUOTE);
	RETURN_TOKEN('`');
}
yy180:
		YYDEBUG(180, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(181, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	RETURN_TOKEN(T_BAD_CHARACTER);
}
yy182:
		YYDEBUG(182, *YYCURSOR);
		yyaccept = 4;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(183, *YYCURSOR);
		if (yybm[0+yych] & 2) {
			goto yy182;
		}
		if (yych == '\\') goto yy185;
yy184:
		YYDEBUG(184, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_NAME_FULLY_QUALIFIED, 1);
}
yy185:
		YYDEBUG(185, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy186;
			if (yych <= 'Z') goto yy187;
			if (yych >= '_') goto yy187;
		} else {
			if (yych <= '`') goto yy186;
			if (yych <= 'z') goto yy187;
			if (yych >= 0x80) goto yy187;
		}
yy186:
		YYDEBUG(186, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 45) {
			if (yyaccept <= 22) {
				if (yyaccept <= 11) {
					if (yyaccept <= 5) {
						if (yyaccept <= 2) {
							if (yyaccept <= 1) {
								if (yyaccept == 0) {
									goto yy115;
								} else {
									goto yy133;
								}
							} else {
								goto yy142;
							}
						} else {
							if (yyaccept <= 4) {
								if (yyaccept == 3) {
									goto yy169;
								} else {
									goto yy184;
								}
							} else {
								goto yy194;
							}
						}
					} else {
						if (yyaccept <= 8) {
							if (yyaccept <= 7) {
								if (yyaccept == 6) {
									goto yy197;
								} else {
									goto yy219;
								}
							} else {
								goto yy225;
							}
						} else {
							if (yyaccept <= 10) {
								if (yyaccept == 9) {
									goto yy231;
								} else {
									goto yy240;
								}
							} else {
								goto yy242;
							}
						}
					}
				} else {
					if (yyaccept <= 17) {
						if (yyaccept <= 14) {
							if (yyaccept <= 13) {
								if (yyaccept == 12) {
									goto yy256;
								} else {
									goto yy276;
								}
							} else {
								goto yy309;
							}
						} else {
							if (yyaccept <= 16) {
								if (yyaccept == 15) {
									goto yy335;
								} else {
									goto yy340;
								}
							} else {
								goto yy346;
							}
						}
					} else {
						if (yyaccept <= 20) {
							if (yyaccept <= 19) {
								if (yyaccept == 18) {
									goto yy354;
								} else {
									goto yy365;
								}
							} else {
								goto yy370;
							}
						} else {
							if (yyaccept == 21) {
								goto yy377;
							} else {
								goto yy384;
							}
						}
					}
				}
			} else {
				if (yyaccept <= 34) {
					if (yyaccept <= 28) {
						if (yyaccept <= 25) {
							if (yyaccept <= 24) {
								if (yyaccept == 23) {
									goto yy397;
								} else {
									goto yy401;
								}
							} else {
								goto yy405;
							}
						} else {
							if (yyaccept <= 27) {
								if (yyaccept == 26) {
									goto yy488;
								} else {
									goto yy492;
								}
							} else {
								goto yy500;
							}
						}
					} else {
						if (yyaccept <= 31) {
							if (yyaccept <= 30) {
								if (yyaccept == 29) {
									goto yy504;
								} else {
									goto yy542;
								}
							} else {
								goto yy551;
							}
						} else {
							if (yyaccept <= 33) {
								if (yyaccept == 32) {
									goto yy557;
								} else {
									goto yy559;
								}
							} else {
								goto yy564;
							}
						}
					}
				} else {
					if (yyaccept <= 40) {
						if (yyaccept <= 37) {
							if (yyaccept <= 36) {
								if (yyaccept == 35) {
									goto yy569;
								} else {
									goto yy577;
								}
							} else {
								goto yy583;
							}
						} else {
							if (yyaccept <= 39) {
								if (yyaccept == 38) {
									goto yy590;
								} else {
									goto yy595;
								}
							} else {
								goto yy600;
							}
						}
					} else {
						if (yyaccept <= 43) {
							if (yyaccept <= 42) {
								if (yyaccept == 41) {
									goto yy604;
								} else {
									goto yy606;
								}
							} else {
								goto yy613;
							}
						} else {
							if (yyaccept == 44) {
								goto yy618;
							} else {
								goto yy620;
							}
						}
					}
				}
			}
		} else {
			if (yyaccept <= 68) {
				if (yyaccept <= 57) {
					if (yyaccept <= 51) {
						if (yyaccept <= 48) {
							if (yyaccept <= 47) {
								if (yyaccept == 46) {
									goto yy627;
								} else {
									goto yy635;
								}
							} else {
								goto yy641;
							}
						} else {
							if (yyaccept <= 50) {
								if (yyaccept == 49) {
									goto yy648;
								} else {
									goto yy656;
								}
							} else {
								goto yy662;
							}
						}
					} else {
						if (yyaccept <= 54) {
							if (yyaccept <= 53) {
								if (yyaccept == 52) {
									goto yy671;
								} else {
									goto yy675;
								}
							} else {
								goto yy679;
							}
						} else {
							if (yyaccept <= 56) {
								if (yyaccept == 55) {
									goto yy683;
								} else {
									goto yy688;
								}
							} else {
								goto yy706;
							}
						}
					}
				} else {
					if (yyaccept <= 63) {
						if (yyaccept <= 60) {
							if (yyaccept <= 59) {
								if (yyaccept == 58) {
									goto yy712;
								} else {
									goto yy716;
								}
							} else {
								goto yy727;
							}
						} else {
							if (yyaccept <= 62) {
								if (yyaccept == 61) {
									goto yy729;
								} else {
									goto yy734;
								}
							} else {
								goto yy737;
							}
						}
					} else {
						if (yyaccept <= 66) {
							if (yyaccept <= 65) {
								if (yyaccept == 64) {
									goto yy746;
								} else {
									goto yy748;
								}
							} else {
								goto yy751;
							}
						} else {
							if (yyaccept == 67) {
								goto yy754;
							} else {
								goto yy763;
							}
						}
					}
				}
			} else {
				if (yyaccept <= 79) {
					if (yyaccept <= 74) {
						if (yyaccept <= 71) {
							if (yyaccept <= 70) {
								if (yyaccept == 69) {
									goto yy765;
								} else {
									goto yy770;
								}
							} else {
								goto yy774;
							}
						} else {
							if (yyaccept <= 73) {
								if (yyaccept == 72) {
									goto yy777;
								} else {
									goto yy781;
								}
							} else {
								goto yy783;
							}
						}
					} else {
						if (yyaccept <= 77) {
							if (yyaccept <= 76) {
								if (yyaccept == 75) {
									goto yy790;
								} else {
									goto yy795;
								}
							} else {
								goto yy808;
							}
						} else {
							if (yyaccept == 78) {
								goto yy810;
							} else {
								goto yy813;
							}
						}
					}
				} else {
					if (yyaccept <= 85) {
						if (yyaccept <= 82) {
							if (yyaccept <= 81) {
								if (yyaccept == 80) {
									goto yy820;
								} else {
									goto yy847;
								}
							} else {
								goto yy853;
							}
						} else {
							if (yyaccept <= 84) {
								if (yyaccept == 83) {
									goto yy855;
								} else {
									goto yy858;
								}
							} else {
								goto yy863;
							}
						}
					} else {
						if (yyaccept <= 88) {
							if (yyaccept <= 87) {
								if (yyaccept == 86) {
									goto yy870;
								} else {
									goto yy874;
								}
							} else {
								goto yy877;
							}
						} else {
							if (yyaccept == 89) {
								goto yy880;
							} else {
								goto yy883;
							}
						}
					}
				}
			}
		}
yy187:
		YYDEBUG(187, *YYCURSOR);
		yyaccept = 4;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(188, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy184;
				if (yych <= '9') goto yy187;
				goto yy184;
			} else {
				if (yych <= 'Z') goto yy187;
				if (yych <= '[') goto yy184;
				goto yy185;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy187;
				goto yy184;
			} else {
				if (yych <= 'z') goto yy187;
				if (yych <= 0x7F) goto yy184;
				goto yy187;
			}
		}
yy189:
		YYDEBUG(189, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy190:
		YYDEBUG(190, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy115;
				if (yych <= '9') goto yy189;
				goto yy115;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych <= '[') goto yy115;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
				goto yy115;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych <= 0x7F) goto yy115;
				goto yy189;
			}
		}
yy191:
		YYDEBUG(191, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy186;
			if (yych <= 'Z') goto yy192;
			if (yych <= '^') goto yy186;
		} else {
			if (yych <= '`') goto yy186;
			if (yych <= 'z') goto yy192;
			if (yych <= 0x7F) goto yy186;
		}
yy192:
		YYDEBUG(192, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(193, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy194;
				if (yych <= '9') goto yy192;
			} else {
				if (yych <= 'Z') goto yy192;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy192;
			} else {
				if (yych <= 'z') goto yy192;
				if (yych >= 0x80) goto yy192;
			}
		}
yy194:
		YYDEBUG(194, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_NAME_QUALIFIED, 0);
}
yy195:
		YYDEBUG(195, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy186;
		if (yych <= '9') goto yy212;
		goto yy186;
yy196:
		YYDEBUG(196, *YYCURSOR);
		yyaccept = 6;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy208;
yy197:
		YYDEBUG(197, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	const char *end;
	size_t len = yyleng;
	char *dnum = yytext;
	bool contains_underscores = (memchr(dnum, '_', len) != NULL);

	if (contains_underscores) {
		dnum = estrndup(dnum, len);
		strip_underscores(dnum, &len);
	}

	ZVAL_DOUBLE(zendlval, zend_strtod(dnum, &end));
	/* errno isn't checked since we allow HUGE_VAL/INF overflow */
	ZEND_ASSERT(end == dnum + len);
	if (contains_underscores) {
		efree(dnum);
	}
	RETURN_TOKEN_WITH_VAL(T_DNUMBER);
}
yy198:
		YYDEBUG(198, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
yy199:
		YYDEBUG(199, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy198;
		}
		if (yych <= 'E') {
			if (yych == '.') goto yy196;
			if (yych <= 'D') goto yy169;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy169;
				goto yy195;
			} else {
				if (yych != 'e') goto yy169;
			}
		}
yy200:
		YYDEBUG(200, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ',') {
			if (yych != '+') goto yy186;
		} else {
			if (yych <= '-') goto yy201;
			if (yych <= '/') goto yy186;
			if (yych <= '9') goto yy202;
			goto yy186;
		}
yy201:
		YYDEBUG(201, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '/') goto yy186;
		if (yych >= ':') goto yy186;
yy202:
		YYDEBUG(202, *YYCURSOR);
		yyaccept = 6;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(203, *YYCURSOR);
		if (yych <= '/') goto yy197;
		if (yych <= '9') goto yy202;
		if (yych != '_') goto yy197;
yy204:
		YYDEBUG(204, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy186;
		if (yych >= ':') goto yy186;
yy205:
		YYDEBUG(205, *YYCURSOR);
		yyaccept = 6;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(206, *YYCURSOR);
		if (yych <= '/') goto yy197;
		if (yych <= '9') goto yy205;
		if (yych == '_') goto yy204;
		goto yy197;
yy207:
		YYDEBUG(207, *YYCURSOR);
		yyaccept = 6;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy208:
		YYDEBUG(208, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy197;
			if (yych <= '9') goto yy207;
			if (yych <= 'D') goto yy197;
			goto yy200;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy197;
			} else {
				if (yych == 'e') goto yy200;
				goto yy197;
			}
		}
yy209:
		YYDEBUG(209, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy186;
		if (yych >= ':') goto yy186;
yy210:
		YYDEBUG(210, *YYCURSOR);
		yyaccept = 6;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(211, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy197;
			if (yych <= '9') goto yy210;
			if (yych <= 'D') goto yy197;
			goto yy200;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy197;
				goto yy209;
			} else {
				if (yych == 'e') goto yy200;
				goto yy197;
			}
		}
yy212:
		YYDEBUG(212, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(213, *YYCURSOR);
		if (yych <= 'D') {
			if (yych <= '.') {
				if (yych <= '-') goto yy169;
				goto yy196;
			} else {
				if (yych <= '/') goto yy169;
				if (yych <= '9') goto yy212;
				goto yy169;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'E') goto yy200;
				if (yych <= '^') goto yy169;
				goto yy195;
			} else {
				if (yych == 'e') goto yy200;
				goto yy169;
			}
		}
yy214:
		YYDEBUG(214, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy229;
		}
		goto yy186;
yy215:
		YYDEBUG(215, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 16) {
			goto yy223;
		}
		goto yy186;
yy216:
		YYDEBUG(216, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 8) {
			goto yy217;
		}
		goto yy186;
yy217:
		YYDEBUG(217, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(218, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy217;
		}
		if (yych == '_') goto yy220;
yy219:
		YYDEBUG(219, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* The +/- 2 skips "0b" */
	size_t len = yyleng - 2;
	char *end, *bin = yytext + 2;
	bool contains_underscores;

	/* Skip any leading 0s */
	while (len > 0 && (*bin == '0' || *bin == '_')) {
		++bin;
		--len;
	}

	contains_underscores = (memchr(bin, '_', len) != NULL);

	if (contains_underscores) {
		bin = estrndup(bin, len);
		strip_underscores(bin, &len);
	}

	if (len < SIZEOF_ZEND_LONG * 8) {
		if (len == 0) {
			ZVAL_LONG(zendlval, 0);
		} else {
			errno = 0;
			ZVAL_LONG(zendlval, ZEND_STRTOL(bin, &end, 2));
			ZEND_ASSERT(!errno && end == bin + len);
		}
		if (contains_underscores) {
			efree(bin);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	} else {
		ZVAL_DOUBLE(zendlval, zend_bin_strtod(bin, (const char **)&end));
		/* errno isn't checked since we allow HUGE_VAL/INF overflow */
		ZEND_ASSERT(end == bin + len);
		if (contains_underscores) {
			efree(bin);
		}
		RETURN_TOKEN_WITH_VAL(T_DNUMBER);
	}
}
yy220:
		YYDEBUG(220, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy186;
		if (yych >= '2') goto yy186;
yy221:
		YYDEBUG(221, *YYCURSOR);
		yyaccept = 7;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(222, *YYCURSOR);
		if (yych <= '/') goto yy219;
		if (yych <= '1') goto yy221;
		if (yych == '_') goto yy220;
		goto yy219;
yy223:
		YYDEBUG(223, *YYCURSOR);
		yyaccept = 8;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(224, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy223;
		}
		if (yych == '_') goto yy226;
yy225:
		YYDEBUG(225, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* The +/- 2 skips "0o" */
	size_t len = yyleng - 2;
	char *end, *octal = yytext + 2;
	bool contains_underscores = (memchr(octal, '_', len) != NULL);

	/* Skip any leading 0s */
	while (len > 0 && (*octal == '0' || *octal == '_')) {
		++octal;
		--len;
	}

	if (len == 0) {
		ZVAL_LONG(zendlval, 0);
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	}

	if (contains_underscores) {
		octal = estrndup(octal, len);
		strip_underscores(octal, &len);
	}

	errno = 0;

	ZVAL_LONG(zendlval, ZEND_STRTOL(octal, &end, 8));

	ZEND_ASSERT(end == octal + len);

	if (!errno) {
		if (contains_underscores) {
			efree(octal);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	}

	/* Overflow */
	ZEND_ASSERT(errno == ERANGE);
	/* Reset errno */
	errno = 0;

	/* zend_oct_strtod skips leading '0' */
	ZVAL_DOUBLE(zendlval, zend_oct_strtod(octal, (const char **)&end));
	ZEND_ASSERT(!errno);
	ZEND_ASSERT(end == octal + len);
	if (contains_underscores) {
		efree(octal);
	}
	RETURN_TOKEN_WITH_VAL(T_DNUMBER);
}
yy226:
		YYDEBUG(226, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy186;
		if (yych >= '8') goto yy186;
yy227:
		YYDEBUG(227, *YYCURSOR);
		yyaccept = 8;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(228, *YYCURSOR);
		if (yych <= '/') goto yy225;
		if (yych <= '7') goto yy227;
		if (yych == '_') goto yy226;
		goto yy225;
yy229:
		YYDEBUG(229, *YYCURSOR);
		yyaccept = 9;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(230, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy229;
		}
		if (yych == '_') goto yy232;
yy231:
		YYDEBUG(231, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* The +/- 2 skips "0x" */
	size_t len = yyleng - 2;
	char *end, *hex = yytext + 2;
	bool contains_underscores;

	/* Skip any leading 0s */
	while (len > 0 && (*hex == '0' || *hex == '_')) {
		++hex;
		--len;
	}

	contains_underscores = (memchr(hex, '_', len) != NULL);

	if (contains_underscores) {
		hex = estrndup(hex, len);
		strip_underscores(hex, &len);
	}

	if (len < SIZEOF_ZEND_LONG * 2 || (len == SIZEOF_ZEND_LONG * 2 && *hex <= '7')) {
		if (len == 0) {
			ZVAL_LONG(zendlval, 0);
		} else {
			errno = 0;
			ZVAL_LONG(zendlval, ZEND_STRTOL(hex, &end, 16));
			ZEND_ASSERT(!errno && end == hex + len);
		}
		if (contains_underscores) {
			efree(hex);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	} else {
		ZVAL_DOUBLE(zendlval, zend_hex_strtod(hex, (const char **)&end));
		/* errno isn't checked since we allow HUGE_VAL/INF overflow */
		ZEND_ASSERT(end == hex + len);
		if (contains_underscores) {
			efree(hex);
		}
		RETURN_TOKEN_WITH_VAL(T_DNUMBER);
	}
}
yy232:
		YYDEBUG(232, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '@') {
			if (yych <= '/') goto yy186;
			if (yych >= ':') goto yy186;
		} else {
			if (yych <= 'F') goto yy233;
			if (yych <= '`') goto yy186;
			if (yych >= 'g') goto yy186;
		}
yy233:
		YYDEBUG(233, *YYCURSOR);
		yyaccept = 9;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(234, *YYCURSOR);
		if (yych <= 'F') {
			if (yych <= '/') goto yy231;
			if (yych <= '9') goto yy233;
			if (yych <= '@') goto yy231;
			goto yy233;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy231;
				goto yy232;
			} else {
				if (yych <= '`') goto yy231;
				if (yych <= 'f') goto yy233;
				goto yy231;
			}
		}
yy235:
		YYDEBUG(235, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(236, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy235;
			} else {
				if (yych <= '@') goto yy237;
				if (yych <= 'Z') goto yy235;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy235;
			} else {
				if (yych <= 'z') goto yy235;
				if (yych >= 0x80) goto yy235;
			}
		}
yy237:
		YYDEBUG(237, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy238:
		YYDEBUG(238, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy239;
		if (yych != 'r') goto yy190;
yy239:
		YYDEBUG(239, *YYCURSOR);
		yyaccept = 10;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy240;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy240:
		YYDEBUG(240, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_XOR);
}
yy241:
		YYDEBUG(241, *YYCURSOR);
		yyaccept = 11;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy242;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy242:
		YYDEBUG(242, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_OR);
}
yy243:
		YYDEBUG(243, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(244, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_XOR_EQUAL);
}
yy245:
		YYDEBUG(245, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(246, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_BOOLEAN_OR);
}
yy247:
		YYDEBUG(247, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(248, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_OR_EQUAL);
}
yy249:
		YYDEBUG(249, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(250, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_BOOLEAN_AND);
}
yy251:
		YYDEBUG(251, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(252, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_AND_EQUAL);
}
yy253:
		YYDEBUG(253, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(254, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_MOD_EQUAL);
}
yy255:
		YYDEBUG(255, *YYCURSOR);
		yyaccept = 12;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '*') goto yy260;
yy256:
		YYDEBUG(256, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	int doc_com;

	if (yyleng > 2) {
		doc_com = 1;
		RESET_DOC_COMMENT();
	} else {
		doc_com = 0;
	}

	while (YYCURSOR < YYLIMIT) {
		if (*YYCURSOR++ == '*' && *YYCURSOR == '/') {
			break;
		}
	}

	if (YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	} else {
		zend_throw_exception_ex(zend_ce_parse_error, 0, "Unterminated comment starting line %d", CG(zend_lineno));
		if (PARSER_MODE()) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	yyleng = YYCURSOR - SCNG(yy_text);
	HANDLE_NEWLINES(yytext, yyleng);

	if (doc_com) {
		CG(doc_comment) = zend_string_init(yytext, yyleng, 0);
		RETURN_OR_SKIP_TOKEN(T_DOC_COMMENT);
	}

	RETURN_OR_SKIP_TOKEN(T_COMMENT);
}
yy257:
		YYDEBUG(257, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy121;
yy258:
		YYDEBUG(258, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(259, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DIV_EQUAL);
}
yy260:
		YYDEBUG(260, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy261;
		}
		goto yy186;
yy261:
		YYDEBUG(261, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(262, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy261;
		}
		goto yy256;
yy263:
		YYDEBUG(263, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy267;
		YYDEBUG(264, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_POW);
}
yy265:
		YYDEBUG(265, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(266, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_MUL_EQUAL);
}
yy267:
		YYDEBUG(267, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(268, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_POW_EQUAL);
}
yy269:
		YYDEBUG(269, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy273;
		YYDEBUG(270, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SR);
}
yy271:
		YYDEBUG(271, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(272, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_GREATER_OR_EQUAL);
}
yy273:
		YYDEBUG(273, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(274, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SR_EQUAL);
}
yy275:
		YYDEBUG(275, *YYCURSOR);
		yyaccept = 13;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') goto yy276;
		if (yych <= '<') goto yy285;
		if (yych <= '=') goto yy283;
yy276:
		YYDEBUG(276, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SL);
}
yy277:
		YYDEBUG(277, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy281;
		YYDEBUG(278, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_SMALLER_OR_EQUAL);
}
yy279:
		YYDEBUG(279, *YYCURSOR);
		++YYCURSOR;
yy280:
		YYDEBUG(280, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_NOT_EQUAL);
}
yy281:
		YYDEBUG(281, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(282, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SPACESHIP);
}
yy283:
		YYDEBUG(283, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(284, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_SL_EQUAL);
}
yy285:
		YYDEBUG(285, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(286, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy285;
		}
		if (yych <= 'Z') {
			if (yych <= '&') {
				if (yych == '"') goto yy290;
				goto yy186;
			} else {
				if (yych <= '\'') goto yy289;
				if (yych <= '@') goto yy186;
			}
		} else {
			if (yych <= '`') {
				if (yych != '_') goto yy186;
			} else {
				if (yych <= 'z') goto yy287;
				if (yych <= 0x7F) goto yy186;
			}
		}
yy287:
		YYDEBUG(287, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(288, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\f') {
				if (yych == '\n') goto yy294;
				goto yy186;
			} else {
				if (yych <= '\r') goto yy296;
				if (yych <= '/') goto yy186;
				if (yych <= '9') goto yy287;
				goto yy186;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy287;
				if (yych <= '^') goto yy186;
				goto yy287;
			} else {
				if (yych <= '`') goto yy186;
				if (yych <= 'z') goto yy287;
				if (yych <= 0x7F) goto yy186;
				goto yy287;
			}
		}
yy289:
		YYDEBUG(289, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\'') goto yy186;
		if (yych <= '/') goto yy298;
		if (yych <= '9') goto yy186;
		goto yy298;
yy290:
		YYDEBUG(290, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy186;
		if (yych <= '/') goto yy292;
		if (yych <= '9') goto yy186;
		goto yy292;
yy291:
		YYDEBUG(291, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy292:
		YYDEBUG(292, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych != '"') goto yy186;
			} else {
				if (yych <= '9') goto yy291;
				if (yych <= '@') goto yy186;
				goto yy291;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy291;
				goto yy186;
			} else {
				if (yych <= 'z') goto yy291;
				if (yych <= 0x7F) goto yy186;
				goto yy291;
			}
		}
yy293:
		YYDEBUG(293, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy294;
		if (yych == '\r') goto yy296;
		goto yy186;
yy294:
		YYDEBUG(294, *YYCURSOR);
		++YYCURSOR;
yy295:
		YYDEBUG(295, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	char *s;
	unsigned char *saved_cursor;
	int bprefix = (yytext[0] != '<') ? 1 : 0, spacing = 0, indentation = 0;
	zend_heredoc_label *heredoc_label = emalloc(sizeof(zend_heredoc_label));
	bool is_heredoc = 1;

	CG(zend_lineno)++;
	heredoc_label->length = yyleng-bprefix-3-1-(yytext[yyleng-2]=='\r'?1:0);
	s = yytext+bprefix+3;
	while ((*s == ' ') || (*s == '\t')) {
		s++;
		heredoc_label->length--;
	}

	if (*s == '\'') {
		s++;
		heredoc_label->length -= 2;
		is_heredoc = 0;

		BEGIN(ST_NOWDOC);
	} else {
		if (*s == '"') {
			s++;
			heredoc_label->length -= 2;
		}

		BEGIN(ST_HEREDOC);
	}

	heredoc_label->label = estrndup(s, heredoc_label->length);
	heredoc_label->indentation_uses_spaces = 0;
	heredoc_label->indentation = 0;
	saved_cursor = YYCURSOR;

	zend_ptr_stack_push(&SCNG(heredoc_label_stack), (void *) heredoc_label);

	while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
		if (*YYCURSOR == '\t') {
			spacing |= HEREDOC_USING_TABS;
		} else {
			spacing |= HEREDOC_USING_SPACES;
		}
		++YYCURSOR;
		++indentation;
	}

	if (YYCURSOR == YYLIMIT) {
		YYCURSOR = saved_cursor;
		RETURN_TOKEN(T_START_HEREDOC);
	}

	/* Check for ending label on the next line */
	if (heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, s, heredoc_label->length)) {
		if (!IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
			if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
				zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
				if (PARSER_MODE()) {
					RETURN_TOKEN(T_ERROR);
				}
			}

			YYCURSOR = saved_cursor;
			heredoc_label->indentation = indentation;

			BEGIN(ST_END_HEREDOC);
			RETURN_TOKEN(T_START_HEREDOC);
		}
	}

	YYCURSOR = saved_cursor;

	if (is_heredoc && !SCNG(heredoc_scan_ahead)) {
		zend_lex_state current_state;
		zend_string *saved_doc_comment = CG(doc_comment);
		int heredoc_nesting_level = 1;
		int first_token = 0;
		int error = 0;

		zend_save_lexical_state(&current_state);

		SCNG(heredoc_scan_ahead) = 1;
		SCNG(heredoc_indentation) = 0;
		SCNG(heredoc_indentation_uses_spaces) = 0;
		LANG_SCNG(on_event) = NULL;
		CG(doc_comment) = NULL;

		zend_ptr_stack_reverse_apply(&current_state.heredoc_label_stack, copy_heredoc_label_stack);

		zend_exception_save();
		while (heredoc_nesting_level) {
			zval zv;
			int retval;

			ZVAL_UNDEF(&zv);
			retval = lex_scan(&zv, NULL);
			zval_ptr_dtor_nogc(&zv);

			if (EG(exception)) {
				zend_clear_exception();
				break;
			}

			if (!first_token) {
				first_token = retval;
			}

			switch (retval) {
				case T_START_HEREDOC:
					++heredoc_nesting_level;
					break;
				case T_END_HEREDOC:
					--heredoc_nesting_level;
					break;
				case END:
					heredoc_nesting_level = 0;
			}
		}
		zend_exception_restore();

		if (
		    (first_token == T_VARIABLE
		     || first_token == T_DOLLAR_OPEN_CURLY_BRACES
		     || first_token == T_CURLY_OPEN
		    ) && SCNG(heredoc_indentation)) {
			zend_throw_exception_ex(zend_ce_parse_error, 0, "Invalid body indentation level (expecting an indentation level of at least %d)", SCNG(heredoc_indentation));
			error = 1;
		}

		heredoc_label->indentation = SCNG(heredoc_indentation);
		heredoc_label->indentation_uses_spaces = SCNG(heredoc_indentation_uses_spaces);

		zend_restore_lexical_state(&current_state);
		SCNG(heredoc_scan_ahead) = 0;
		CG(increment_lineno) = 0;
		CG(doc_comment) = saved_doc_comment;

		if (PARSER_MODE() && error) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	RETURN_TOKEN(T_START_HEREDOC);
}
yy296:
		YYDEBUG(296, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy294;
		goto yy295;
yy297:
		YYDEBUG(297, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy298:
		YYDEBUG(298, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '\'') goto yy293;
				goto yy186;
			} else {
				if (yych <= '9') goto yy297;
				if (yych <= '@') goto yy186;
				goto yy297;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy297;
				goto yy186;
			} else {
				if (yych <= 'z') goto yy297;
				if (yych <= 0x7F) goto yy186;
				goto yy297;
			}
		}
yy299:
		YYDEBUG(299, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '=') goto yy280;
		YYDEBUG(300, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(301, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_NOT_IDENTICAL);
}
yy302:
		YYDEBUG(302, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(303, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_PLUS_EQUAL);
}
yy304:
		YYDEBUG(304, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(305, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_INC);
}
yy306:
		YYDEBUG(306, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy307;
		if (yych != 's') goto yy190;
yy307:
		YYDEBUG(307, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy308;
		if (yych != 't') goto yy190;
yy308:
		YYDEBUG(308, *YYCURSOR);
		yyaccept = 14;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy309;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy309:
		YYDEBUG(309, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LIST);
}
yy310:
		YYDEBUG(310, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy314;
		YYDEBUG(311, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_EQUAL);
}
yy312:
		YYDEBUG(312, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(313, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DOUBLE_ARROW);
}
yy314:
		YYDEBUG(314, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(315, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_IS_IDENTICAL);
}
yy316:
		YYDEBUG(316, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'C':
		case 'c':	goto yy318;
		case 'D':
		case 'd':	goto yy323;
		case 'F':
		case 'f':	goto yy320;
		case 'H':
		case 'h':	goto yy317;
		case 'L':
		case 'l':	goto yy322;
		case 'M':
		case 'm':	goto yy321;
		case 'N':
		case 'n':	goto yy324;
		case 'T':
		case 't':	goto yy319;
		default:	goto yy190;
		}
yy317:
		YYDEBUG(317, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy385;
		if (yych == 'a') goto yy385;
		goto yy190;
yy318:
		YYDEBUG(318, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy378;
		if (yych == 'l') goto yy378;
		goto yy190;
yy319:
		YYDEBUG(319, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy371;
		if (yych == 'r') goto yy371;
		goto yy190;
yy320:
		YYDEBUG(320, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'I') goto yy355;
			if (yych <= 'T') goto yy190;
			goto yy356;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy190;
				goto yy355;
			} else {
				if (yych == 'u') goto yy356;
				goto yy190;
			}
		}
yy321:
		YYDEBUG(321, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy347;
		if (yych == 'e') goto yy347;
		goto yy190;
yy322:
		YYDEBUG(322, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy341;
		if (yych == 'i') goto yy341;
		goto yy190;
yy323:
		YYDEBUG(323, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy336;
		if (yych == 'i') goto yy336;
		goto yy190;
yy324:
		YYDEBUG(324, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy325;
		if (yych != 'a') goto yy190;
yy325:
		YYDEBUG(325, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy326;
		if (yych != 'm') goto yy190;
yy326:
		YYDEBUG(326, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy327;
		if (yych != 'e') goto yy190;
yy327:
		YYDEBUG(327, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy328;
		if (yych != 's') goto yy190;
yy328:
		YYDEBUG(328, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy329;
		if (yych != 'p') goto yy190;
yy329:
		YYDEBUG(329, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy330;
		if (yych != 'a') goto yy190;
yy330:
		YYDEBUG(330, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy331;
		if (yych != 'c') goto yy190;
yy331:
		YYDEBUG(331, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy332;
		if (yych != 'e') goto yy190;
yy332:
		YYDEBUG(332, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(333, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(334, *YYCURSOR);
		yyaccept = 15;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy335;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy335:
		YYDEBUG(335, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_NS_C);
}
yy336:
		YYDEBUG(336, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy337;
		if (yych != 'r') goto yy190;
yy337:
		YYDEBUG(337, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(338, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(339, *YYCURSOR);
		yyaccept = 16;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy340;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy340:
		YYDEBUG(340, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DIR);
}
yy341:
		YYDEBUG(341, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy342;
		if (yych != 'n') goto yy190;
yy342:
		YYDEBUG(342, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy343;
		if (yych != 'e') goto yy190;
yy343:
		YYDEBUG(343, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(344, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(345, *YYCURSOR);
		yyaccept = 17;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy346;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy346:
		YYDEBUG(346, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LINE);
}
yy347:
		YYDEBUG(347, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy348;
		if (yych != 't') goto yy190;
yy348:
		YYDEBUG(348, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy349;
		if (yych != 'h') goto yy190;
yy349:
		YYDEBUG(349, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy350;
		if (yych != 'o') goto yy190;
yy350:
		YYDEBUG(350, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy351;
		if (yych != 'd') goto yy190;
yy351:
		YYDEBUG(351, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(352, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(353, *YYCURSOR);
		yyaccept = 18;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy354;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy354:
		YYDEBUG(354, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_METHOD_C);
}
yy355:
		YYDEBUG(355, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy366;
		if (yych == 'l') goto yy366;
		goto yy190;
yy356:
		YYDEBUG(356, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy357;
		if (yych != 'n') goto yy190;
yy357:
		YYDEBUG(357, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy358;
		if (yych != 'c') goto yy190;
yy358:
		YYDEBUG(358, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy359;
		if (yych != 't') goto yy190;
yy359:
		YYDEBUG(359, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy360;
		if (yych != 'i') goto yy190;
yy360:
		YYDEBUG(360, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy361;
		if (yych != 'o') goto yy190;
yy361:
		YYDEBUG(361, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy362;
		if (yych != 'n') goto yy190;
yy362:
		YYDEBUG(362, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(363, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(364, *YYCURSOR);
		yyaccept = 19;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy365;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy365:
		YYDEBUG(365, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FUNC_C);
}
yy366:
		YYDEBUG(366, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy367;
		if (yych != 'e') goto yy190;
yy367:
		YYDEBUG(367, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(368, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(369, *YYCURSOR);
		yyaccept = 20;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy370;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy370:
		YYDEBUG(370, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FILE);
}
yy371:
		YYDEBUG(371, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy372;
		if (yych != 'a') goto yy190;
yy372:
		YYDEBUG(372, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy373;
		if (yych != 'i') goto yy190;
yy373:
		YYDEBUG(373, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy374;
		if (yych != 't') goto yy190;
yy374:
		YYDEBUG(374, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(375, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(376, *YYCURSOR);
		yyaccept = 21;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy377;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy377:
		YYDEBUG(377, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_TRAIT_C);
}
yy378:
		YYDEBUG(378, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy379;
		if (yych != 'a') goto yy190;
yy379:
		YYDEBUG(379, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy380;
		if (yych != 's') goto yy190;
yy380:
		YYDEBUG(380, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy381;
		if (yych != 's') goto yy190;
yy381:
		YYDEBUG(381, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(382, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(383, *YYCURSOR);
		yyaccept = 22;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy384;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy384:
		YYDEBUG(384, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CLASS_C);
}
yy385:
		YYDEBUG(385, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy386;
		if (yych != 'l') goto yy190;
yy386:
		YYDEBUG(386, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy387;
		if (yych != 't') goto yy190;
yy387:
		YYDEBUG(387, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych != '_') goto yy190;
		YYDEBUG(388, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy389;
		if (yych != 'c') goto yy190;
yy389:
		YYDEBUG(389, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy390;
		if (yych != 'o') goto yy190;
yy390:
		YYDEBUG(390, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy391;
		if (yych != 'm') goto yy190;
yy391:
		YYDEBUG(391, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy392;
		if (yych != 'p') goto yy190;
yy392:
		YYDEBUG(392, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy393;
		if (yych != 'i') goto yy190;
yy393:
		YYDEBUG(393, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy394;
		if (yych != 'l') goto yy190;
yy394:
		YYDEBUG(394, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy395;
		if (yych != 'e') goto yy190;
yy395:
		YYDEBUG(395, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy396;
		if (yych != 'r') goto yy190;
yy396:
		YYDEBUG(396, *YYCURSOR);
		yyaccept = 23;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy397;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy397:
		YYDEBUG(397, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_HALT_COMPILER);
}
yy398:
		YYDEBUG(398, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy402;
		if (yych == 's') goto yy402;
		goto yy190;
yy399:
		YYDEBUG(399, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy400;
		if (yych != 'e') goto yy190;
yy400:
		YYDEBUG(400, *YYCURSOR);
		yyaccept = 24;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy401;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy401:
		YYDEBUG(401, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_USE);
}
yy402:
		YYDEBUG(402, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy403;
		if (yych != 'e') goto yy190;
yy403:
		YYDEBUG(403, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy404;
		if (yych != 't') goto yy190;
yy404:
		YYDEBUG(404, *YYCURSOR);
		yyaccept = 25;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy405;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy405:
		YYDEBUG(405, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_UNSET);
}
yy406:
		YYDEBUG(406, *YYCURSOR);
		++YYCURSOR;
		YYFILL(7);
		yych = *YYCURSOR;
yy407:
		YYDEBUG(407, *YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy406;
					if (yych <= 0x1F) goto yy186;
					goto yy406;
				} else {
					if (yych <= 'A') {
						if (yych <= '@') goto yy186;
						goto yy411;
					} else {
						if (yych <= 'B') goto yy409;
						if (yych <= 'C') goto yy186;
						goto yy414;
					}
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy415;
					if (yych <= 'H') goto yy186;
					goto yy416;
				} else {
					if (yych <= 'O') {
						if (yych <= 'N') goto yy186;
						goto yy410;
					} else {
						if (yych <= 'Q') goto yy186;
						if (yych <= 'R') goto yy413;
						goto yy412;
					}
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'a') {
					if (yych == 'U') goto yy408;
					if (yych <= '`') goto yy186;
					goto yy411;
				} else {
					if (yych <= 'c') {
						if (yych <= 'b') goto yy409;
						goto yy186;
					} else {
						if (yych <= 'd') goto yy414;
						if (yych <= 'e') goto yy186;
						goto yy415;
					}
				}
			} else {
				if (yych <= 'q') {
					if (yych <= 'i') {
						if (yych <= 'h') goto yy186;
						goto yy416;
					} else {
						if (yych == 'o') goto yy410;
						goto yy186;
					}
				} else {
					if (yych <= 's') {
						if (yych <= 'r') goto yy413;
						goto yy412;
					} else {
						if (yych != 'u') goto yy186;
					}
				}
			}
		}
yy408:
		YYDEBUG(408, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy479;
		if (yych == 'n') goto yy479;
		goto yy186;
yy409:
		YYDEBUG(409, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy466;
			if (yych <= 'N') goto yy186;
			goto yy467;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy186;
				goto yy466;
			} else {
				if (yych == 'o') goto yy467;
				goto yy186;
			}
		}
yy410:
		YYDEBUG(410, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy458;
		if (yych == 'b') goto yy458;
		goto yy186;
yy411:
		YYDEBUG(411, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy451;
		if (yych == 'r') goto yy451;
		goto yy186;
yy412:
		YYDEBUG(412, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy443;
		if (yych == 't') goto yy443;
		goto yy186;
yy413:
		YYDEBUG(413, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy437;
		if (yych == 'e') goto yy437;
		goto yy186;
yy414:
		YYDEBUG(414, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy433;
		if (yych == 'o') goto yy433;
		goto yy186;
yy415:
		YYDEBUG(415, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy426;
		if (yych == 'l') goto yy426;
		goto yy186;
yy416:
		YYDEBUG(416, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy417;
		if (yych != 'n') goto yy186;
yy417:
		YYDEBUG(417, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy418;
		if (yych != 't') goto yy186;
yy418:
		YYDEBUG(418, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy419;
		if (yych != 'e') goto yy421;
yy419:
		YYDEBUG(419, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy424;
		if (yych == 'g') goto yy424;
		goto yy186;
yy420:
		YYDEBUG(420, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy421:
		YYDEBUG(421, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy420;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy420;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(422, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(423, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_INT_CAST);
}
yy424:
		YYDEBUG(424, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy425;
		if (yych != 'e') goto yy186;
yy425:
		YYDEBUG(425, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy420;
		if (yych == 'r') goto yy420;
		goto yy186;
yy426:
		YYDEBUG(426, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy427;
		if (yych != 'o') goto yy186;
yy427:
		YYDEBUG(427, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy428;
		if (yych != 'a') goto yy186;
yy428:
		YYDEBUG(428, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy429;
		if (yych != 't') goto yy186;
yy429:
		YYDEBUG(429, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(430, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy429;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy429;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(431, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(432, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DOUBLE_CAST);
}
yy433:
		YYDEBUG(433, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy434;
		if (yych != 'u') goto yy186;
yy434:
		YYDEBUG(434, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy435;
		if (yych != 'b') goto yy186;
yy435:
		YYDEBUG(435, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy436;
		if (yych != 'l') goto yy186;
yy436:
		YYDEBUG(436, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy429;
		if (yych == 'e') goto yy429;
		goto yy186;
yy437:
		YYDEBUG(437, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy438;
		if (yych != 'a') goto yy186;
yy438:
		YYDEBUG(438, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy439;
		if (yych != 'l') goto yy186;
yy439:
		YYDEBUG(439, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(440, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy439;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy439;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(441, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(442, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (PARSER_MODE()) {
		zend_throw_exception(zend_ce_parse_error, "The (real) cast has been removed, use (float) instead", 0);
		RETURN_TOKEN(T_ERROR);
	}
	RETURN_TOKEN(T_DOUBLE_CAST);
}
yy443:
		YYDEBUG(443, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy444;
		if (yych != 'r') goto yy186;
yy444:
		YYDEBUG(444, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy445;
		if (yych != 'i') goto yy186;
yy445:
		YYDEBUG(445, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy446;
		if (yych != 'n') goto yy186;
yy446:
		YYDEBUG(446, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy447;
		if (yych != 'g') goto yy186;
yy447:
		YYDEBUG(447, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(448, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy447;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy447;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(449, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(450, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_STRING_CAST);
}
yy451:
		YYDEBUG(451, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy452;
		if (yych != 'r') goto yy186;
yy452:
		YYDEBUG(452, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy453;
		if (yych != 'a') goto yy186;
yy453:
		YYDEBUG(453, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy454;
		if (yych != 'y') goto yy186;
yy454:
		YYDEBUG(454, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(455, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy454;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy454;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(456, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(457, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_ARRAY_CAST);
}
yy458:
		YYDEBUG(458, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'J') goto yy459;
		if (yych != 'j') goto yy186;
yy459:
		YYDEBUG(459, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy460;
		if (yych != 'e') goto yy186;
yy460:
		YYDEBUG(460, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy461;
		if (yych != 'c') goto yy186;
yy461:
		YYDEBUG(461, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy462;
		if (yych != 't') goto yy186;
yy462:
		YYDEBUG(462, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(463, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy462;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy462;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(464, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(465, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_OBJECT_CAST);
}
yy466:
		YYDEBUG(466, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy476;
		if (yych == 'n') goto yy476;
		goto yy186;
yy467:
		YYDEBUG(467, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy468;
		if (yych != 'o') goto yy186;
yy468:
		YYDEBUG(468, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy469;
		if (yych != 'l') goto yy186;
yy469:
		YYDEBUG(469, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy474;
		if (yych == 'e') goto yy474;
		goto yy471;
yy470:
		YYDEBUG(470, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy471:
		YYDEBUG(471, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy470;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy470;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(472, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(473, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_BOOL_CAST);
}
yy474:
		YYDEBUG(474, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy475;
		if (yych != 'a') goto yy186;
yy475:
		YYDEBUG(475, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy470;
		if (yych == 'n') goto yy470;
		goto yy186;
yy476:
		YYDEBUG(476, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy477;
		if (yych != 'a') goto yy186;
yy477:
		YYDEBUG(477, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy478;
		if (yych != 'r') goto yy186;
yy478:
		YYDEBUG(478, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy447;
		if (yych == 'y') goto yy447;
		goto yy186;
yy479:
		YYDEBUG(479, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy480;
		if (yych != 's') goto yy186;
yy480:
		YYDEBUG(480, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy481;
		if (yych != 'e') goto yy186;
yy481:
		YYDEBUG(481, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy482;
		if (yych != 't') goto yy186;
yy482:
		YYDEBUG(482, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(483, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy482;
			goto yy186;
		} else {
			if (yych <= ' ') goto yy482;
			if (yych != ')') goto yy186;
		}
		YYDEBUG(484, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(485, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_UNSET_CAST);
}
yy486:
		YYDEBUG(486, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy487;
		if (yych != 'r') goto yy190;
yy487:
		YYDEBUG(487, *YYCURSOR);
		yyaccept = 26;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy488;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy488:
		YYDEBUG(488, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_VAR);
}
yy489:
		YYDEBUG(489, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy493;
		if (yych == 'm') goto yy493;
		goto yy190;
yy490:
		YYDEBUG(490, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy491;
		if (yych != 'w') goto yy190;
yy491:
		YYDEBUG(491, *YYCURSOR);
		yyaccept = 27;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy492;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy492:
		YYDEBUG(492, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_NEW);
}
yy493:
		YYDEBUG(493, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy494;
		if (yych != 'e') goto yy190;
yy494:
		YYDEBUG(494, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy495;
		if (yych != 's') goto yy190;
yy495:
		YYDEBUG(495, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy496;
		if (yych != 'p') goto yy190;
yy496:
		YYDEBUG(496, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy497;
		if (yych != 'a') goto yy190;
yy497:
		YYDEBUG(497, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy498;
		if (yych != 'c') goto yy190;
yy498:
		YYDEBUG(498, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy499;
		if (yych != 'e') goto yy190;
yy499:
		YYDEBUG(499, *YYCURSOR);
		yyaccept = 28;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy500;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy501;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy500:
		YYDEBUG(500, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_NAMESPACE);
}
yy501:
		YYDEBUG(501, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy186;
			if (yych <= 'Z') goto yy502;
			if (yych <= '^') goto yy186;
		} else {
			if (yych <= '`') goto yy186;
			if (yych <= 'z') goto yy502;
			if (yych <= 0x7F) goto yy186;
		}
yy502:
		YYDEBUG(502, *YYCURSOR);
		yyaccept = 29;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(503, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy504;
				if (yych <= '9') goto yy502;
			} else {
				if (yych <= 'Z') goto yy502;
				if (yych >= '\\') goto yy501;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy502;
			} else {
				if (yych <= 'z') goto yy502;
				if (yych >= 0x80) goto yy502;
			}
		}
yy504:
		YYDEBUG(504, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_NAME_RELATIVE, sizeof("namespace\\") - 1);
}
yy505:
		YYDEBUG(505, *YYCURSOR);
		yyaccept = 6;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(506, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy197;
			if (yych <= '9') goto yy505;
			if (yych <= 'D') goto yy197;
			goto yy200;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy197;
				goto yy512;
			} else {
				if (yych == 'e') goto yy200;
				goto yy197;
			}
		}
yy507:
		YYDEBUG(507, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(508, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_CONCAT_EQUAL);
}
yy509:
		YYDEBUG(509, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '.') goto yy186;
		YYDEBUG(510, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(511, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_ELLIPSIS);
}
yy512:
		YYDEBUG(512, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy186;
		if (yych >= ':') goto yy186;
yy513:
		YYDEBUG(513, *YYCURSOR);
		yyaccept = 6;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(514, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy197;
			if (yych <= '9') goto yy513;
			if (yych <= 'D') goto yy197;
			goto yy200;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy197;
				goto yy512;
			} else {
				if (yych == 'e') goto yy200;
				goto yy197;
			}
		}
yy515:
		YYDEBUG(515, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(516, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_PAAMAYIM_NEKUDOTAYIM);
}
yy517:
		YYDEBUG(517, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy518:
		YYDEBUG(518, *YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy136;
			if (yych <= '\n') goto yy517;
			goto yy136;
		} else {
			if (yych <= '\r') goto yy517;
			if (yych == ' ') goto yy517;
			goto yy136;
		}
yy519:
		YYDEBUG(519, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '\n') goto yy528;
		if (yych == '\r') goto yy529;
yy520:
		YYDEBUG(520, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	BEGIN(INITIAL);
	if (yytext[yyleng-1] != '>') {
		CG(increment_lineno) = 1;
	}
	if (PARSER_MODE()) {
		RETURN_TOKEN(';');  /* implicit ';' at php-end tag */
	}
	RETURN_TOKEN(T_CLOSE_TAG);
}
yy521:
		YYDEBUG(521, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '=') goto yy526;
		YYDEBUG(522, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_COALESCE);
}
yy523:
		YYDEBUG(523, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '>') goto yy186;
		YYDEBUG(524, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(525, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN(T_NULLSAFE_OBJECT_OPERATOR);
}
yy526:
		YYDEBUG(526, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(527, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_COALESCE_EQUAL);
}
yy528:
		YYDEBUG(528, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy520;
yy529:
		YYDEBUG(529, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy528;
		goto yy520;
yy530:
		YYDEBUG(530, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(531, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_MINUS_EQUAL);
}
yy532:
		YYDEBUG(532, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(533, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_DEC);
}
yy534:
		YYDEBUG(534, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(535, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN(T_OBJECT_OPERATOR);
}
yy536:
		YYDEBUG(536, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'I') goto yy543;
			if (yych <= 'N') goto yy190;
			goto yy544;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy190;
				goto yy543;
			} else {
				if (yych == 'o') goto yy544;
				goto yy190;
			}
		}
yy537:
		YYDEBUG(537, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy538;
		if (yych != 'b') goto yy190;
yy538:
		YYDEBUG(538, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy539;
		if (yych != 'l') goto yy190;
yy539:
		YYDEBUG(539, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy540;
		if (yych != 'i') goto yy190;
yy540:
		YYDEBUG(540, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy541;
		if (yych != 'c') goto yy190;
yy541:
		YYDEBUG(541, *YYCURSOR);
		yyaccept = 30;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy542;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy542:
		YYDEBUG(542, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PUBLIC);
}
yy543:
		YYDEBUG(543, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'V') {
			if (yych == 'N') goto yy552;
			if (yych <= 'U') goto yy190;
			goto yy553;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy190;
				goto yy552;
			} else {
				if (yych == 'v') goto yy553;
				goto yy190;
			}
		}
yy544:
		YYDEBUG(544, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy545;
		if (yych != 't') goto yy190;
yy545:
		YYDEBUG(545, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy546;
		if (yych != 'e') goto yy190;
yy546:
		YYDEBUG(546, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy547;
		if (yych != 'c') goto yy190;
yy547:
		YYDEBUG(547, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy548;
		if (yych != 't') goto yy190;
yy548:
		YYDEBUG(548, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy549;
		if (yych != 'e') goto yy190;
yy549:
		YYDEBUG(549, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy550;
		if (yych != 'd') goto yy190;
yy550:
		YYDEBUG(550, *YYCURSOR);
		yyaccept = 31;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy551;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy551:
		YYDEBUG(551, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PROTECTED);
}
yy552:
		YYDEBUG(552, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy558;
		if (yych == 't') goto yy558;
		goto yy190;
yy553:
		YYDEBUG(553, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy554;
		if (yych != 'a') goto yy190;
yy554:
		YYDEBUG(554, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy555;
		if (yych != 't') goto yy190;
yy555:
		YYDEBUG(555, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy556;
		if (yych != 'e') goto yy190;
yy556:
		YYDEBUG(556, *YYCURSOR);
		yyaccept = 32;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy557;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy557:
		YYDEBUG(557, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PRIVATE);
}
yy558:
		YYDEBUG(558, *YYCURSOR);
		yyaccept = 33;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy559;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy559:
		YYDEBUG(559, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_PRINT);
}
yy560:
		YYDEBUG(560, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy565;
		if (yych == 'o') goto yy565;
		goto yy190;
yy561:
		YYDEBUG(561, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy562;
		if (yych != 't') goto yy190;
yy562:
		YYDEBUG(562, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy563;
		if (yych != 'o') goto yy190;
yy563:
		YYDEBUG(563, *YYCURSOR);
		yyaccept = 34;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy564;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy564:
		YYDEBUG(564, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_GOTO);
}
yy565:
		YYDEBUG(565, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy566;
		if (yych != 'b') goto yy190;
yy566:
		YYDEBUG(566, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy567;
		if (yych != 'a') goto yy190;
yy567:
		YYDEBUG(567, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy568;
		if (yych != 'l') goto yy190;
yy568:
		YYDEBUG(568, *YYCURSOR);
		yyaccept = 35;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy569;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy569:
		YYDEBUG(569, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_GLOBAL);
}
yy570:
		YYDEBUG(570, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy578;
		goto yy186;
yy571:
		YYDEBUG(571, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy177;
yy572:
		YYDEBUG(572, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy175;
yy573:
		YYDEBUG(573, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy574;
		if (yych != 'e') goto yy190;
yy574:
		YYDEBUG(574, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy575;
		if (yych != 'a') goto yy190;
yy575:
		YYDEBUG(575, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'K') goto yy576;
		if (yych != 'k') goto yy190;
yy576:
		YYDEBUG(576, *YYCURSOR);
		yyaccept = 36;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy577;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy577:
		YYDEBUG(577, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_BREAK);
}
yy578:
		YYDEBUG(578, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy285;
		goto yy186;
yy579:
		YYDEBUG(579, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy580;
		if (yych != 't') goto yy190;
yy580:
		YYDEBUG(580, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy581;
		if (yych != 'c') goto yy190;
yy581:
		YYDEBUG(581, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy582;
		if (yych != 'h') goto yy190;
yy582:
		YYDEBUG(582, *YYCURSOR);
		yyaccept = 37;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy583;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy583:
		YYDEBUG(583, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_MATCH);
}
yy584:
		YYDEBUG(584, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy591;
		if (yych == 'a') goto yy591;
		goto yy190;
yy585:
		YYDEBUG(585, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy586;
		if (yych != 'i') goto yy190;
yy586:
		YYDEBUG(586, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy587;
		if (yych != 't') goto yy190;
yy587:
		YYDEBUG(587, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy588;
		if (yych != 'c') goto yy190;
yy588:
		YYDEBUG(588, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy589;
		if (yych != 'h') goto yy190;
yy589:
		YYDEBUG(589, *YYCURSOR);
		yyaccept = 38;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy590;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy590:
		YYDEBUG(590, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_SWITCH);
}
yy591:
		YYDEBUG(591, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy592;
		if (yych != 't') goto yy190;
yy592:
		YYDEBUG(592, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy593;
		if (yych != 'i') goto yy190;
yy593:
		YYDEBUG(593, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy594;
		if (yych != 'c') goto yy190;
yy594:
		YYDEBUG(594, *YYCURSOR);
		yyaccept = 39;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy595;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy595:
		YYDEBUG(595, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_STATIC);
}
yy596:
		YYDEBUG(596, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy607;
		if (yych == 's') goto yy607;
		goto yy190;
yy597:
		YYDEBUG(597, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy605;
		if (yych == 'd') goto yy605;
		goto yy190;
yy598:
		YYDEBUG(598, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy601;
		if (yych == 'r') goto yy601;
		goto yy190;
yy599:
		YYDEBUG(599, *YYCURSOR);
		yyaccept = 40;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy600;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy600:
		YYDEBUG(600, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_AS);
}
yy601:
		YYDEBUG(601, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy602;
		if (yych != 'a') goto yy190;
yy602:
		YYDEBUG(602, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy603;
		if (yych != 'y') goto yy190;
yy603:
		YYDEBUG(603, *YYCURSOR);
		yyaccept = 41;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy604;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy604:
		YYDEBUG(604, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ARRAY);
}
yy605:
		YYDEBUG(605, *YYCURSOR);
		yyaccept = 42;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy606;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy606:
		YYDEBUG(606, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_AND);
}
yy607:
		YYDEBUG(607, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy608;
		if (yych != 't') goto yy190;
yy608:
		YYDEBUG(608, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy609;
		if (yych != 'r') goto yy190;
yy609:
		YYDEBUG(609, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy610;
		if (yych != 'a') goto yy190;
yy610:
		YYDEBUG(610, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy611;
		if (yych != 'c') goto yy190;
yy611:
		YYDEBUG(611, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy612;
		if (yych != 't') goto yy190;
yy612:
		YYDEBUG(612, *YYCURSOR);
		yyaccept = 43;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy613;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy613:
		YYDEBUG(613, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ABSTRACT);
}
yy614:
		YYDEBUG(614, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy615;
		if (yych != 'i') goto yy190;
yy615:
		YYDEBUG(615, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy616;
		if (yych != 'l') goto yy190;
yy616:
		YYDEBUG(616, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy617;
		if (yych != 'e') goto yy190;
yy617:
		YYDEBUG(617, *YYCURSOR);
		yyaccept = 44;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy618;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy618:
		YYDEBUG(618, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_WHILE);
}
yy619:
		YYDEBUG(619, *YYCURSOR);
		yyaccept = 45;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy620;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy620:
		YYDEBUG(620, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_IF);
}
yy621:
		YYDEBUG(621, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy663;
		if (yych == 'p') goto yy663;
		goto yy190;
yy622:
		YYDEBUG(622, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'C') {
				if (yych <= 'B') goto yy190;
				goto yy630;
			} else {
				if (yych <= 'R') goto yy190;
				if (yych <= 'S') goto yy628;
				goto yy629;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'c') goto yy630;
				goto yy190;
			} else {
				if (yych <= 's') goto yy628;
				if (yych <= 't') goto yy629;
				goto yy190;
			}
		}
yy623:
		YYDEBUG(623, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy624;
		if (yych != 's') goto yy190;
yy624:
		YYDEBUG(624, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy625;
		if (yych != 'e') goto yy190;
yy625:
		YYDEBUG(625, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy626;
		if (yych != 't') goto yy190;
yy626:
		YYDEBUG(626, *YYCURSOR);
		yyaccept = 46;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy627;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy627:
		YYDEBUG(627, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ISSET);
}
yy628:
		YYDEBUG(628, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy649;
		if (yych == 't') goto yy649;
		goto yy190;
yy629:
		YYDEBUG(629, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy642;
		if (yych == 'e') goto yy642;
		goto yy190;
yy630:
		YYDEBUG(630, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy631;
		if (yych != 'l') goto yy190;
yy631:
		YYDEBUG(631, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy632;
		if (yych != 'u') goto yy190;
yy632:
		YYDEBUG(632, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy633;
		if (yych != 'd') goto yy190;
yy633:
		YYDEBUG(633, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy634;
		if (yych != 'e') goto yy190;
yy634:
		YYDEBUG(634, *YYCURSOR);
		yyaccept = 47;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy635;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy636;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy635:
		YYDEBUG(635, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INCLUDE);
}
yy636:
		YYDEBUG(636, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy637;
		if (yych != 'o') goto yy190;
yy637:
		YYDEBUG(637, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy638;
		if (yych != 'n') goto yy190;
yy638:
		YYDEBUG(638, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy639;
		if (yych != 'c') goto yy190;
yy639:
		YYDEBUG(639, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy640;
		if (yych != 'e') goto yy190;
yy640:
		YYDEBUG(640, *YYCURSOR);
		yyaccept = 48;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy641;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy641:
		YYDEBUG(641, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INCLUDE_ONCE);
}
yy642:
		YYDEBUG(642, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy643;
		if (yych != 'r') goto yy190;
yy643:
		YYDEBUG(643, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy644;
		if (yych != 'f') goto yy190;
yy644:
		YYDEBUG(644, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy645;
		if (yych != 'a') goto yy190;
yy645:
		YYDEBUG(645, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy646;
		if (yych != 'c') goto yy190;
yy646:
		YYDEBUG(646, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy647;
		if (yych != 'e') goto yy190;
yy647:
		YYDEBUG(647, *YYCURSOR);
		yyaccept = 49;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy648;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy648:
		YYDEBUG(648, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INTERFACE);
}
yy649:
		YYDEBUG(649, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych == 'A') goto yy650;
			if (yych <= 'D') goto yy190;
			goto yy651;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy190;
			} else {
				if (yych == 'e') goto yy651;
				goto yy190;
			}
		}
yy650:
		YYDEBUG(650, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy657;
		if (yych == 'n') goto yy657;
		goto yy190;
yy651:
		YYDEBUG(651, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy652;
		if (yych != 'a') goto yy190;
yy652:
		YYDEBUG(652, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy653;
		if (yych != 'd') goto yy190;
yy653:
		YYDEBUG(653, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy654;
		if (yych != 'o') goto yy190;
yy654:
		YYDEBUG(654, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy655;
		if (yych != 'f') goto yy190;
yy655:
		YYDEBUG(655, *YYCURSOR);
		yyaccept = 50;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy656;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy656:
		YYDEBUG(656, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
    RETURN_TOKEN_WITH_IDENT(T_INSTEADOF);
}
yy657:
		YYDEBUG(657, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy658;
		if (yych != 'c') goto yy190;
yy658:
		YYDEBUG(658, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy659;
		if (yych != 'e') goto yy190;
yy659:
		YYDEBUG(659, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy660;
		if (yych != 'o') goto yy190;
yy660:
		YYDEBUG(660, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy661;
		if (yych != 'f') goto yy190;
yy661:
		YYDEBUG(661, *YYCURSOR);
		yyaccept = 51;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy662;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy662:
		YYDEBUG(662, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_INSTANCEOF);
}
yy663:
		YYDEBUG(663, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy664;
		if (yych != 'l') goto yy190;
yy664:
		YYDEBUG(664, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy665;
		if (yych != 'e') goto yy190;
yy665:
		YYDEBUG(665, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy666;
		if (yych != 'm') goto yy190;
yy666:
		YYDEBUG(666, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy667;
		if (yych != 'e') goto yy190;
yy667:
		YYDEBUG(667, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy668;
		if (yych != 'n') goto yy190;
yy668:
		YYDEBUG(668, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy669;
		if (yych != 't') goto yy190;
yy669:
		YYDEBUG(669, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy670;
		if (yych != 's') goto yy190;
yy670:
		YYDEBUG(670, *YYCURSOR);
		yyaccept = 52;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy671;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy671:
		YYDEBUG(671, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_IMPLEMENTS);
}
yy672:
		YYDEBUG(672, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy680;
		if (yych == 'r') goto yy680;
		goto yy190;
yy673:
		YYDEBUG(673, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'Y') {
			if (yych == 'A') goto yy676;
			if (yych <= 'X') goto yy190;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy190;
				goto yy676;
			} else {
				if (yych != 'y') goto yy190;
			}
		}
		YYDEBUG(674, *YYCURSOR);
		yyaccept = 53;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy675;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy675:
		YYDEBUG(675, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_TRY);
}
yy676:
		YYDEBUG(676, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy677;
		if (yych != 'i') goto yy190;
yy677:
		YYDEBUG(677, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy678;
		if (yych != 't') goto yy190;
yy678:
		YYDEBUG(678, *YYCURSOR);
		yyaccept = 54;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy679;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy679:
		YYDEBUG(679, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_TRAIT);
}
yy680:
		YYDEBUG(680, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy681;
		if (yych != 'o') goto yy190;
yy681:
		YYDEBUG(681, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy682;
		if (yych != 'w') goto yy190;
yy682:
		YYDEBUG(682, *YYCURSOR);
		yyaccept = 55;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy683;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy683:
		YYDEBUG(683, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_THROW);
}
yy684:
		YYDEBUG(684, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy685;
		if (yych != 'e') goto yy190;
yy685:
		YYDEBUG(685, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy686;
		if (yych != 'l') goto yy190;
yy686:
		YYDEBUG(686, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy687;
		if (yych != 'd') goto yy190;
yy687:
		YYDEBUG(687, *YYCURSOR);
		yyaccept = 56;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy688;
				if (yych <= '\n') goto yy689;
				if (yych >= '\r') goto yy689;
			} else {
				if (yych <= ' ') {
					if (yych >= ' ') goto yy689;
				} else {
					if (yych <= '/') goto yy688;
					if (yych <= '9') goto yy189;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= 'Z') goto yy189;
				if (yych == '\\') goto yy191;
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy189;
				} else {
					if (yych <= 'z') goto yy189;
					if (yych >= 0x80) goto yy189;
				}
			}
		}
yy688:
		YYDEBUG(688, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_YIELD);
}
yy689:
		YYDEBUG(689, *YYCURSOR);
		++YYCURSOR;
		YYFILL(5);
		yych = *YYCURSOR;
		YYDEBUG(690, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy186;
				goto yy689;
			} else {
				if (yych == '\r') goto yy689;
				goto yy186;
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ' ') goto yy689;
				if (yych <= 'E') goto yy186;
			} else {
				if (yych != 'f') goto yy186;
			}
		}
		YYDEBUG(691, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy692;
		if (yych != 'r') goto yy186;
yy692:
		YYDEBUG(692, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy693;
		if (yych != 'o') goto yy186;
yy693:
		YYDEBUG(693, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy694;
		if (yych != 'm') goto yy186;
yy694:
		YYDEBUG(694, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy186;
			} else {
				if (yych <= '@') goto yy695;
				if (yych <= 'Z') goto yy186;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy186;
			} else {
				if (yych <= 'z') goto yy186;
				if (yych >= 0x80) goto yy186;
			}
		}
yy695:
		YYDEBUG(695, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(696, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	HANDLE_NEWLINES(yytext, yyleng);
	RETURN_TOKEN_WITH_IDENT(T_YIELD_FROM);
}
yy697:
		YYDEBUG(697, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(698, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	enter_nesting('[');
	RETURN_TOKEN(T_ATTRIBUTE);
}
yy699:
		YYDEBUG(699, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych == 'Q') goto yy701;
			if (yych <= 'S') goto yy190;
		} else {
			if (yych <= 'q') {
				if (yych <= 'p') goto yy190;
				goto yy701;
			} else {
				if (yych != 't') goto yy190;
			}
		}
		YYDEBUG(700, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy713;
		if (yych == 'u') goto yy713;
		goto yy190;
yy701:
		YYDEBUG(701, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy702;
		if (yych != 'u') goto yy190;
yy702:
		YYDEBUG(702, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy703;
		if (yych != 'i') goto yy190;
yy703:
		YYDEBUG(703, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy704;
		if (yych != 'r') goto yy190;
yy704:
		YYDEBUG(704, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy705;
		if (yych != 'e') goto yy190;
yy705:
		YYDEBUG(705, *YYCURSOR);
		yyaccept = 57;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy706;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy707;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy706:
		YYDEBUG(706, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_REQUIRE);
}
yy707:
		YYDEBUG(707, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy708;
		if (yych != 'o') goto yy190;
yy708:
		YYDEBUG(708, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy709;
		if (yych != 'n') goto yy190;
yy709:
		YYDEBUG(709, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy710;
		if (yych != 'c') goto yy190;
yy710:
		YYDEBUG(710, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy711;
		if (yych != 'e') goto yy190;
yy711:
		YYDEBUG(711, *YYCURSOR);
		yyaccept = 58;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy712;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy712:
		YYDEBUG(712, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_REQUIRE_ONCE);
}
yy713:
		YYDEBUG(713, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy714;
		if (yych != 'r') goto yy190;
yy714:
		YYDEBUG(714, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy715;
		if (yych != 'n') goto yy190;
yy715:
		YYDEBUG(715, *YYCURSOR);
		yyaccept = 59;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy716;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy716:
		YYDEBUG(716, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_RETURN);
}
yy717:
		YYDEBUG(717, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy190;
				goto yy740;
			} else {
				if (yych <= 'R') goto yy190;
				if (yych <= 'S') goto yy739;
				goto yy738;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'l') goto yy740;
				goto yy190;
			} else {
				if (yych <= 's') goto yy739;
				if (yych <= 't') goto yy738;
				goto yy190;
			}
		}
yy718:
		YYDEBUG(718, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'A') goto yy730;
			if (yych <= 'N') goto yy190;
			goto yy731;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy190;
				goto yy730;
			} else {
				if (yych == 'o') goto yy731;
				goto yy190;
			}
		}
yy719:
		YYDEBUG(719, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy720;
		if (yych != 'n') goto yy190;
yy720:
		YYDEBUG(720, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'R') goto yy190;
			if (yych >= 'T') goto yy722;
		} else {
			if (yych <= 'r') goto yy190;
			if (yych <= 's') goto yy721;
			if (yych <= 't') goto yy722;
			goto yy190;
		}
yy721:
		YYDEBUG(721, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy728;
		if (yych == 't') goto yy728;
		goto yy190;
yy722:
		YYDEBUG(722, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy723;
		if (yych != 'i') goto yy190;
yy723:
		YYDEBUG(723, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy724;
		if (yych != 'n') goto yy190;
yy724:
		YYDEBUG(724, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy725;
		if (yych != 'u') goto yy190;
yy725:
		YYDEBUG(725, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy726;
		if (yych != 'e') goto yy190;
yy726:
		YYDEBUG(726, *YYCURSOR);
		yyaccept = 60;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy727;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy727:
		YYDEBUG(727, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CONTINUE);
}
yy728:
		YYDEBUG(728, *YYCURSOR);
		yyaccept = 61;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy729;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy729:
		YYDEBUG(729, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CONST);
}
yy730:
		YYDEBUG(730, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy735;
		if (yych == 's') goto yy735;
		goto yy190;
yy731:
		YYDEBUG(731, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy732;
		if (yych != 'n') goto yy190;
yy732:
		YYDEBUG(732, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy733;
		if (yych != 'e') goto yy190;
yy733:
		YYDEBUG(733, *YYCURSOR);
		yyaccept = 62;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy734;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy734:
		YYDEBUG(734, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CLONE);
}
yy735:
		YYDEBUG(735, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy736;
		if (yych != 's') goto yy190;
yy736:
		YYDEBUG(736, *YYCURSOR);
		yyaccept = 63;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy737;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy737:
		YYDEBUG(737, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CLASS);
}
yy738:
		YYDEBUG(738, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy749;
		if (yych == 'c') goto yy749;
		goto yy190;
yy739:
		YYDEBUG(739, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy747;
		if (yych == 'e') goto yy747;
		goto yy190;
yy740:
		YYDEBUG(740, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy741;
		if (yych != 'l') goto yy190;
yy741:
		YYDEBUG(741, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy742;
		if (yych != 'a') goto yy190;
yy742:
		YYDEBUG(742, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy743;
		if (yych != 'b') goto yy190;
yy743:
		YYDEBUG(743, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy744;
		if (yych != 'l') goto yy190;
yy744:
		YYDEBUG(744, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy745;
		if (yych != 'e') goto yy190;
yy745:
		YYDEBUG(745, *YYCURSOR);
		yyaccept = 64;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy746;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy746:
		YYDEBUG(746, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CALLABLE);
}
yy747:
		YYDEBUG(747, *YYCURSOR);
		yyaccept = 65;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy748;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy748:
		YYDEBUG(748, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CASE);
}
yy749:
		YYDEBUG(749, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy750;
		if (yych != 'h') goto yy190;
yy750:
		YYDEBUG(750, *YYCURSOR);
		yyaccept = 66;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy751;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy751:
		YYDEBUG(751, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_CATCH);
}
yy752:
		YYDEBUG(752, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy771;
		if (yych == 'n') goto yy771;
		goto yy190;
yy753:
		YYDEBUG(753, *YYCURSOR);
		yyaccept = 67;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy754;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy754:
		YYDEBUG(754, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FN);
}
yy755:
		YYDEBUG(755, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy764;
		if (yych == 'r') goto yy764;
		goto yy190;
yy756:
		YYDEBUG(756, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy757;
		if (yych != 'n') goto yy190;
yy757:
		YYDEBUG(757, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy758;
		if (yych != 'c') goto yy190;
yy758:
		YYDEBUG(758, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy759;
		if (yych != 't') goto yy190;
yy759:
		YYDEBUG(759, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy760;
		if (yych != 'i') goto yy190;
yy760:
		YYDEBUG(760, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy761;
		if (yych != 'o') goto yy190;
yy761:
		YYDEBUG(761, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy762;
		if (yych != 'n') goto yy190;
yy762:
		YYDEBUG(762, *YYCURSOR);
		yyaccept = 68;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy763;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy763:
		YYDEBUG(763, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FUNCTION);
}
yy764:
		YYDEBUG(764, *YYCURSOR);
		yyaccept = 69;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'D') {
				if (yych <= '/') goto yy765;
				if (yych <= '9') goto yy189;
				if (yych >= 'A') goto yy189;
			} else {
				if (yych <= 'E') goto yy766;
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= 'd') {
				if (yych == '_') goto yy189;
				if (yych >= 'a') goto yy189;
			} else {
				if (yych <= 'e') goto yy766;
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy765:
		YYDEBUG(765, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FOR);
}
yy766:
		YYDEBUG(766, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy767;
		if (yych != 'a') goto yy190;
yy767:
		YYDEBUG(767, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy768;
		if (yych != 'c') goto yy190;
yy768:
		YYDEBUG(768, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy769;
		if (yych != 'h') goto yy190;
yy769:
		YYDEBUG(769, *YYCURSOR);
		yyaccept = 70;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy770;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy770:
		YYDEBUG(770, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FOREACH);
}
yy771:
		YYDEBUG(771, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy772;
		if (yych != 'a') goto yy190;
yy772:
		YYDEBUG(772, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy773;
		if (yych != 'l') goto yy190;
yy773:
		YYDEBUG(773, *YYCURSOR);
		yyaccept = 71;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'K') {
				if (yych <= '/') goto yy774;
				if (yych <= '9') goto yy189;
				if (yych >= 'A') goto yy189;
			} else {
				if (yych <= 'L') goto yy775;
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= 'k') {
				if (yych == '_') goto yy189;
				if (yych >= 'a') goto yy189;
			} else {
				if (yych <= 'l') goto yy775;
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy774:
		YYDEBUG(774, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FINAL);
}
yy775:
		YYDEBUG(775, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy776;
		if (yych != 'y') goto yy190;
yy776:
		YYDEBUG(776, *YYCURSOR);
		yyaccept = 72;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy777;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy777:
		YYDEBUG(777, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_FINALLY);
}
yy778:
		YYDEBUG(778, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'F') {
			if (yych == 'C') goto yy784;
			if (yych <= 'E') goto yy190;
			goto yy785;
		} else {
			if (yych <= 'c') {
				if (yych <= 'b') goto yy190;
				goto yy784;
			} else {
				if (yych == 'f') goto yy785;
				goto yy190;
			}
		}
yy779:
		YYDEBUG(779, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy782;
		if (yych == 'e') goto yy782;
		goto yy190;
yy780:
		YYDEBUG(780, *YYCURSOR);
		yyaccept = 73;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy781;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy781:
		YYDEBUG(781, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DO);
}
yy782:
		YYDEBUG(782, *YYCURSOR);
		yyaccept = 74;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy783;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy783:
		YYDEBUG(783, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EXIT);
}
yy784:
		YYDEBUG(784, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy791;
		if (yych == 'l') goto yy791;
		goto yy190;
yy785:
		YYDEBUG(785, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy786;
		if (yych != 'a') goto yy190;
yy786:
		YYDEBUG(786, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy787;
		if (yych != 'u') goto yy190;
yy787:
		YYDEBUG(787, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy788;
		if (yych != 'l') goto yy190;
yy788:
		YYDEBUG(788, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy789;
		if (yych != 't') goto yy190;
yy789:
		YYDEBUG(789, *YYCURSOR);
		yyaccept = 75;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy790;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy790:
		YYDEBUG(790, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DEFAULT);
}
yy791:
		YYDEBUG(791, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy792;
		if (yych != 'a') goto yy190;
yy792:
		YYDEBUG(792, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy793;
		if (yych != 'r') goto yy190;
yy793:
		YYDEBUG(793, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy794;
		if (yych != 'e') goto yy190;
yy794:
		YYDEBUG(794, *YYCURSOR);
		yyaccept = 76;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy795;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy795:
		YYDEBUG(795, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_DECLARE);
}
yy796:
		YYDEBUG(796, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy881;
		if (yych == 'h') goto yy881;
		goto yy190;
yy797:
		YYDEBUG(797, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy875;
		if (yych == 's') goto yy875;
		goto yy190;
yy798:
		YYDEBUG(798, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy871;
		if (yych == 'p') goto yy871;
		goto yy190;
yy799:
		YYDEBUG(799, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'D') goto yy814;
			if (yych <= 'T') goto yy190;
			goto yy815;
		} else {
			if (yych <= 'd') {
				if (yych <= 'c') goto yy190;
				goto yy814;
			} else {
				if (yych == 'u') goto yy815;
				goto yy190;
			}
		}
yy800:
		YYDEBUG(800, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy811;
		if (yych == 'a') goto yy811;
		goto yy190;
yy801:
		YYDEBUG(801, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych == 'I') goto yy802;
			if (yych <= 'S') goto yy190;
			goto yy803;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy190;
			} else {
				if (yych == 't') goto yy803;
				goto yy190;
			}
		}
yy802:
		YYDEBUG(802, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy809;
		if (yych == 't') goto yy809;
		goto yy190;
yy803:
		YYDEBUG(803, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy804;
		if (yych != 'e') goto yy190;
yy804:
		YYDEBUG(804, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy805;
		if (yych != 'n') goto yy190;
yy805:
		YYDEBUG(805, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy806;
		if (yych != 'd') goto yy190;
yy806:
		YYDEBUG(806, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy807;
		if (yych != 's') goto yy190;
yy807:
		YYDEBUG(807, *YYCURSOR);
		yyaccept = 77;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy808;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy808:
		YYDEBUG(808, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EXTENDS);
}
yy809:
		YYDEBUG(809, *YYCURSOR);
		yyaccept = 78;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy810;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy810:
		YYDEBUG(810, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EXIT);
}
yy811:
		YYDEBUG(811, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy812;
		if (yych != 'l') goto yy190;
yy812:
		YYDEBUG(812, *YYCURSOR);
		yyaccept = 79;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy813;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy813:
		YYDEBUG(813, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EVAL);
}
yy814:
		YYDEBUG(814, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		YYDEBUG(-1, yych);
		switch (yych) {
		case 'D':
		case 'd':	goto yy838;
		case 'F':
		case 'f':	goto yy839;
		case 'I':
		case 'i':	goto yy840;
		case 'S':
		case 's':	goto yy841;
		case 'W':
		case 'w':	goto yy842;
		default:	goto yy190;
		}
yy815:
		YYDEBUG(815, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy816;
		if (yych != 'm') goto yy190;
yy816:
		YYDEBUG(816, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy115;
				if (yych <= '\n') goto yy817;
				if (yych <= '\f') goto yy115;
			} else {
				if (yych <= ' ') {
					if (yych <= 0x1F) goto yy115;
				} else {
					if (yych <= '/') goto yy115;
					if (yych <= '9') goto yy189;
					goto yy115;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= 'Z') goto yy189;
				if (yych == '\\') goto yy191;
				goto yy115;
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy189;
					goto yy115;
				} else {
					if (yych <= 'z') goto yy189;
					if (yych <= 0x7F) goto yy115;
					goto yy189;
				}
			}
		}
yy817:
		YYDEBUG(817, *YYCURSOR);
		++YYCURSOR;
		YYFILL(10);
		yych = *YYCURSOR;
		YYDEBUG(818, *YYCURSOR);
		if (yych <= 'I') {
			if (yych <= 0x1F) {
				if (yych <= '\n') {
					if (yych <= 0x08) goto yy186;
					goto yy817;
				} else {
					if (yych == '\r') goto yy817;
					goto yy186;
				}
			} else {
				if (yych <= 'D') {
					if (yych <= ' ') goto yy817;
					if (yych <= '@') goto yy186;
				} else {
					if (yych <= 'E') goto yy821;
					if (yych >= 'I') goto yy822;
				}
			}
		} else {
			if (yych <= 'd') {
				if (yych <= '^') {
					if (yych >= '[') goto yy186;
				} else {
					if (yych == '`') goto yy186;
				}
			} else {
				if (yych <= 'i') {
					if (yych <= 'e') goto yy821;
					if (yych >= 'i') goto yy822;
				} else {
					if (yych <= 'z') goto yy819;
					if (yych <= 0x7F) goto yy186;
				}
			}
		}
yy819:
		YYDEBUG(819, *YYCURSOR);
		++YYCURSOR;
yy820:
		YYDEBUG(820, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(4);
	RETURN_TOKEN_WITH_IDENT(T_ENUM);
}
yy821:
		YYDEBUG(821, *YYCURSOR);
		yyaccept = 80;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'X') goto yy833;
		if (yych == 'x') goto yy833;
		goto yy820;
yy822:
		YYDEBUG(822, *YYCURSOR);
		yyaccept = 80;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy823;
		if (yych != 'm') goto yy820;
yy823:
		YYDEBUG(823, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy824;
		if (yych != 'p') goto yy186;
yy824:
		YYDEBUG(824, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy825;
		if (yych != 'l') goto yy186;
yy825:
		YYDEBUG(825, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy826;
		if (yych != 'e') goto yy186;
yy826:
		YYDEBUG(826, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy827;
		if (yych != 'm') goto yy186;
yy827:
		YYDEBUG(827, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy828;
		if (yych != 'e') goto yy186;
yy828:
		YYDEBUG(828, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy829;
		if (yych != 'n') goto yy186;
yy829:
		YYDEBUG(829, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy830;
		if (yych != 't') goto yy186;
yy830:
		YYDEBUG(830, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy831;
		if (yych != 's') goto yy186;
yy831:
		YYDEBUG(831, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(832, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(4);
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy833:
		YYDEBUG(833, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy834;
		if (yych != 't') goto yy186;
yy834:
		YYDEBUG(834, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy835;
		if (yych != 'e') goto yy186;
yy835:
		YYDEBUG(835, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy836;
		if (yych != 'n') goto yy186;
yy836:
		YYDEBUG(836, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy837;
		if (yych != 'd') goto yy186;
yy837:
		YYDEBUG(837, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy831;
		if (yych == 's') goto yy831;
		goto yy186;
yy838:
		YYDEBUG(838, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy864;
		if (yych == 'e') goto yy864;
		goto yy190;
yy839:
		YYDEBUG(839, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy856;
		if (yych == 'o') goto yy856;
		goto yy190;
yy840:
		YYDEBUG(840, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy854;
		if (yych == 'f') goto yy854;
		goto yy190;
yy841:
		YYDEBUG(841, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy848;
		if (yych == 'w') goto yy848;
		goto yy190;
yy842:
		YYDEBUG(842, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy843;
		if (yych != 'h') goto yy190;
yy843:
		YYDEBUG(843, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy844;
		if (yych != 'i') goto yy190;
yy844:
		YYDEBUG(844, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy845;
		if (yych != 'l') goto yy190;
yy845:
		YYDEBUG(845, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy846;
		if (yych != 'e') goto yy190;
yy846:
		YYDEBUG(846, *YYCURSOR);
		yyaccept = 81;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy847;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy847:
		YYDEBUG(847, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDWHILE);
}
yy848:
		YYDEBUG(848, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy849;
		if (yych != 'i') goto yy190;
yy849:
		YYDEBUG(849, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy850;
		if (yych != 't') goto yy190;
yy850:
		YYDEBUG(850, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy851;
		if (yych != 'c') goto yy190;
yy851:
		YYDEBUG(851, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy852;
		if (yych != 'h') goto yy190;
yy852:
		YYDEBUG(852, *YYCURSOR);
		yyaccept = 82;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy853;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy853:
		YYDEBUG(853, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDSWITCH);
}
yy854:
		YYDEBUG(854, *YYCURSOR);
		yyaccept = 83;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy855;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy855:
		YYDEBUG(855, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDIF);
}
yy856:
		YYDEBUG(856, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy857;
		if (yych != 'r') goto yy190;
yy857:
		YYDEBUG(857, *YYCURSOR);
		yyaccept = 84;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'D') {
				if (yych <= '/') goto yy858;
				if (yych <= '9') goto yy189;
				if (yych >= 'A') goto yy189;
			} else {
				if (yych <= 'E') goto yy859;
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= 'd') {
				if (yych == '_') goto yy189;
				if (yych >= 'a') goto yy189;
			} else {
				if (yych <= 'e') goto yy859;
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy858:
		YYDEBUG(858, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDFOR);
}
yy859:
		YYDEBUG(859, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy860;
		if (yych != 'a') goto yy190;
yy860:
		YYDEBUG(860, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy861;
		if (yych != 'c') goto yy190;
yy861:
		YYDEBUG(861, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy862;
		if (yych != 'h') goto yy190;
yy862:
		YYDEBUG(862, *YYCURSOR);
		yyaccept = 85;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy863;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy863:
		YYDEBUG(863, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDFOREACH);
}
yy864:
		YYDEBUG(864, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy865;
		if (yych != 'c') goto yy190;
yy865:
		YYDEBUG(865, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy866;
		if (yych != 'l') goto yy190;
yy866:
		YYDEBUG(866, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy867;
		if (yych != 'a') goto yy190;
yy867:
		YYDEBUG(867, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy868;
		if (yych != 'r') goto yy190;
yy868:
		YYDEBUG(868, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy869;
		if (yych != 'e') goto yy190;
yy869:
		YYDEBUG(869, *YYCURSOR);
		yyaccept = 86;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy870;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy870:
		YYDEBUG(870, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDDECLARE);
}
yy871:
		YYDEBUG(871, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy872;
		if (yych != 't') goto yy190;
yy872:
		YYDEBUG(872, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy873;
		if (yych != 'y') goto yy190;
yy873:
		YYDEBUG(873, *YYCURSOR);
		yyaccept = 87;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy874;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy874:
		YYDEBUG(874, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_EMPTY);
}
yy875:
		YYDEBUG(875, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy876;
		if (yych != 'e') goto yy190;
yy876:
		YYDEBUG(876, *YYCURSOR);
		yyaccept = 88;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'H') {
				if (yych <= '/') goto yy877;
				if (yych <= '9') goto yy189;
				if (yych >= 'A') goto yy189;
			} else {
				if (yych <= 'I') goto yy878;
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= 'h') {
				if (yych == '_') goto yy189;
				if (yych >= 'a') goto yy189;
			} else {
				if (yych <= 'i') goto yy878;
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy877:
		YYDEBUG(877, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ELSE);
}
yy878:
		YYDEBUG(878, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy879;
		if (yych != 'f') goto yy190;
yy879:
		YYDEBUG(879, *YYCURSOR);
		yyaccept = 89;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy880;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy880:
		YYDEBUG(880, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ELSEIF);
}
yy881:
		YYDEBUG(881, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy882;
		if (yych != 'o') goto yy190;
yy882:
		YYDEBUG(882, *YYCURSOR);
		yyaccept = 90;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy883;
				if (yych <= '9') goto yy189;
			} else {
				if (yych <= 'Z') goto yy189;
				if (yych >= '\\') goto yy191;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy189;
			} else {
				if (yych <= 'z') goto yy189;
				if (yych >= 0x80) goto yy189;
			}
		}
yy883:
		YYDEBUG(883, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_IDENT(T_ECHO);
}
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_PROPERTY:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128,   0,   0, 128,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,   0,   0,   0,   0,   0,   0, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,  64, 
			  0,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,   0,   0,   0,   0,   0, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
			 64,  64,  64,  64,  64,  64,  64,  64, 
		};
		YYDEBUG(884, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '>') {
			if (yych <= '\r') {
				if (yych <= 0x08) goto yy893;
				if (yych <= '\n') goto yy886;
				if (yych <= '\f') goto yy893;
			} else {
				if (yych <= ' ') {
					if (yych <= 0x1F) goto yy893;
				} else {
					if (yych == '-') goto yy888;
					goto yy893;
				}
			}
		} else {
			if (yych <= '^') {
				if (yych <= '?') goto yy890;
				if (yych <= '@') goto yy893;
				if (yych <= 'Z') goto yy891;
				goto yy893;
			} else {
				if (yych <= '`') {
					if (yych <= '_') goto yy891;
					goto yy893;
				} else {
					if (yych <= 'z') goto yy891;
					if (yych <= 0x7F) goto yy893;
					goto yy891;
				}
			}
		}
yy886:
		YYDEBUG(886, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy903;
yy887:
		YYDEBUG(887, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	goto return_whitespace;
}
yy888:
		YYDEBUG(888, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) == '>') goto yy900;
yy889:
		YYDEBUG(889, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(0);
	yy_pop_state();
	goto restart;
}
yy890:
		YYDEBUG(890, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '-') goto yy896;
		goto yy889;
yy891:
		YYDEBUG(891, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy895;
yy892:
		YYDEBUG(892, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_pop_state();
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy893:
		YYDEBUG(893, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy889;
yy894:
		YYDEBUG(894, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy895:
		YYDEBUG(895, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy894;
		}
		goto yy892;
yy896:
		YYDEBUG(896, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy898;
		YYDEBUG(897, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy889;
yy898:
		YYDEBUG(898, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(899, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_NULLSAFE_OBJECT_OPERATOR);
}
yy900:
		YYDEBUG(900, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(901, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN(T_OBJECT_OPERATOR);
}
yy902:
		YYDEBUG(902, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy903:
		YYDEBUG(903, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy902;
		}
		goto yy887;
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_VARNAME:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(904, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy908;
			if (yych <= 'Z') goto yy906;
			if (yych <= '^') goto yy908;
		} else {
			if (yych <= '`') goto yy908;
			if (yych <= 'z') goto yy906;
			if (yych <= 0x7F) goto yy908;
		}
yy906:
		YYDEBUG(906, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '_') {
			if (yych <= '@') {
				if (yych <= '/') goto yy907;
				if (yych <= '9') goto yy910;
			} else {
				if (yych <= '[') goto yy910;
				if (yych >= '_') goto yy910;
			}
		} else {
			if (yych <= '|') {
				if (yych <= '`') goto yy907;
				if (yych <= 'z') goto yy910;
			} else {
				if (yych <= '}') goto yy910;
				if (yych >= 0x80) goto yy910;
			}
		}
yy907:
		YYDEBUG(907, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(0);
	yy_pop_state();
	yy_push_state(ST_IN_SCRIPTING);
	goto restart;
}
yy908:
		YYDEBUG(908, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy907;
yy909:
		YYDEBUG(909, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy910:
		YYDEBUG(910, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy909;
		}
		if (yych <= '@') goto yy911;
		if (yych <= '[') goto yy912;
		if (yych == '}') goto yy912;
yy911:
		YYDEBUG(911, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy907;
yy912:
		YYDEBUG(912, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(913, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yyless(yyleng - 1);
	yy_pop_state();
	yy_push_state(ST_IN_SCRIPTING);
	RETURN_TOKEN_WITH_STR(T_STRING_VARNAME, 0);
}
	}
/* *********************************** */
yyc_ST_NOWDOC:
	YYDEBUG(914, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(916, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(917, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
	{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_top(&SCNG(heredoc_label_stack));
	int newline = 0, indentation = 0, spacing = -1;

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			case '\n':
				indentation = spacing = 0;

				while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
					if (*YYCURSOR == '\t') {
						spacing |= HEREDOC_USING_TABS;
					} else {
						spacing |= HEREDOC_USING_SPACES;
					}
					++YYCURSOR;
					++indentation;
				}

				if (YYCURSOR == YYLIMIT) {
					yyleng = YYCURSOR - SCNG(yy_text);
					HANDLE_NEWLINES(yytext, yyleng);
					ZVAL_NULL(zendlval);
					RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
				}

				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, heredoc_label->label, heredoc_label->length)) {
					if (IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
						continue;
					}

					if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
						zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
						if (PARSER_MODE()) {
							RETURN_TOKEN(T_ERROR);
						}
					}

					/* newline before label will be subtracted from returned text, but
					 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
					if (YYCURSOR[-indentation - 2] == '\r' && YYCURSOR[-indentation - 1] == '\n') {
						newline = 2; /* Windows newline */
					} else {
						newline = 1;
					}

					CG(increment_lineno) = 1; /* For newline before label */

					YYCURSOR -= indentation;
					heredoc_label->indentation = indentation;

					BEGIN(ST_END_HEREDOC);

					goto nowdoc_scan_done;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}
	}

nowdoc_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);
	ZVAL_STRINGL(zendlval, yytext, yyleng - newline);

	if (!EG(exception) && spacing != -1 && PARSER_MODE()) {
		bool newline_at_start = *(yytext - 1) == '\n' || *(yytext - 1) == '\r';
		if (!strip_multiline_string_indentation(
				zendlval, indentation, spacing == HEREDOC_USING_SPACES,
				newline_at_start, newline != 0)) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	HANDLE_NEWLINES(yytext, yyleng - newline);
	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
/* *********************************** */
yyc_ST_VAR_OFFSET:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			248, 248, 184, 184, 184, 184, 184, 184, 
			 56,  56,   0,   0,   0,   0,   0,   0, 
			  0,  40,  40,  40,  40,  40,  40,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   0,   0,   0,   0,   8, 
			  0,  40,  40,  40,  40,  40,  40,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   0,   0,   0,   0,   0, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
		};
		YYDEBUG(918, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yych <= '0') {
			if (yych <= ' ') {
				if (yych <= '\f') {
					if (yych <= 0x08) goto yy932;
					if (yych <= '\n') goto yy928;
					goto yy932;
				} else {
					if (yych <= '\r') goto yy928;
					if (yych <= 0x1F) goto yy932;
					goto yy928;
				}
			} else {
				if (yych <= '$') {
					if (yych <= '"') goto yy927;
					if (yych <= '#') goto yy928;
					goto yy923;
				} else {
					if (yych == '\'') goto yy928;
					if (yych <= '/') goto yy927;
				}
			}
		} else {
			if (yych <= ']') {
				if (yych <= 'Z') {
					if (yych <= '9') goto yy922;
					if (yych <= '@') goto yy927;
					goto yy930;
				} else {
					if (yych <= '[') goto yy927;
					if (yych <= '\\') goto yy928;
					goto yy925;
				}
			} else {
				if (yych <= '`') {
					if (yych == '_') goto yy930;
					goto yy927;
				} else {
					if (yych <= 'z') goto yy930;
					if (yych <= '~') goto yy927;
					if (yych <= 0x7F) goto yy932;
					goto yy930;
				}
			}
		}
		YYDEBUG(920, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'X') {
			if (yych <= 'B') {
				if (yych <= '/') goto yy921;
				if (yych <= '9') goto yy949;
				if (yych >= 'B') goto yy947;
			} else {
				if (yych == 'O') goto yy946;
				if (yych >= 'X') goto yy948;
			}
		} else {
			if (yych <= 'b') {
				if (yych == '_') goto yy939;
				if (yych >= 'b') goto yy947;
			} else {
				if (yych <= 'o') {
					if (yych >= 'o') goto yy946;
				} else {
					if (yych == 'x') goto yy948;
				}
			}
		}
yy921:
		YYDEBUG(921, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{ /* Offset could be treated as a long */
	if (yyleng < MAX_LENGTH_OF_LONG - 1 || (yyleng == MAX_LENGTH_OF_LONG - 1 && strcmp(yytext, long_min_digits) < 0)) {
		char *end;
		errno = 0;
		ZVAL_LONG(zendlval, ZEND_STRTOL(yytext, &end, 10));
		if (errno == ERANGE) {
			goto string;
		}
		ZEND_ASSERT(end == yytext + yyleng);
	} else {
string:
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	RETURN_TOKEN_WITH_VAL(T_NUM_STRING);
}
yy922:
		YYDEBUG(922, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		goto yy942;
yy923:
		YYDEBUG(923, *YYCURSOR);
		++YYCURSOR;
		if ((yych = *YYCURSOR) <= '_') {
			if (yych <= '@') goto yy924;
			if (yych <= 'Z') goto yy936;
			if (yych >= '_') goto yy936;
		} else {
			if (yych <= '`') goto yy924;
			if (yych <= 'z') goto yy936;
			if (yych >= 0x80) goto yy936;
		}
yy924:
		YYDEBUG(924, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* Only '[' or '-' can be valid, but returning other tokens will allow a more explicit parse error */
	RETURN_TOKEN(yytext[0]);
}
yy925:
		YYDEBUG(925, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(926, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	yy_pop_state();
	RETURN_TOKEN(']');
}
yy927:
		YYDEBUG(927, *YYCURSOR);
		yych = *++YYCURSOR;
		goto yy924;
yy928:
		YYDEBUG(928, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(929, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	/* Invalid rule to return a more explicit parse error with proper line number */
	yyless(0);
	yy_pop_state();
	ZVAL_NULL(zendlval);
	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
yy930:
		YYDEBUG(930, *YYCURSOR);
		++YYCURSOR;
		yych = *YYCURSOR;
		goto yy935;
yy931:
		YYDEBUG(931, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
yy932:
		YYDEBUG(932, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(933, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	RETURN_TOKEN(T_BAD_CHARACTER);
}
yy934:
		YYDEBUG(934, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy935:
		YYDEBUG(935, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy934;
		}
		goto yy931;
yy936:
		YYDEBUG(936, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(937, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy936;
			} else {
				if (yych <= '@') goto yy938;
				if (yych <= 'Z') goto yy936;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy936;
			} else {
				if (yych <= 'z') goto yy936;
				if (yych >= 0x80) goto yy936;
			}
		}
yy938:
		YYDEBUG(938, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
yy939:
		YYDEBUG(939, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy940;
		if (yych <= '9') goto yy943;
yy940:
		YYDEBUG(940, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept == 0) {
			goto yy921;
		} else {
			goto yy945;
		}
yy941:
		YYDEBUG(941, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy942:
		YYDEBUG(942, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy941;
		}
		if (yych == '_') goto yy939;
		goto yy921;
yy943:
		YYDEBUG(943, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(944, *YYCURSOR);
		if (yych <= '/') goto yy945;
		if (yych <= '9') goto yy943;
		if (yych == '_') goto yy939;
yy945:
		YYDEBUG(945, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
		{ /* Offset must be treated as a string */
	if (yyleng == 1) {
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*(yytext)));
	} else {
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	RETURN_TOKEN_WITH_VAL(T_NUM_STRING);
}
yy946:
		YYDEBUG(946, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy961;
		}
		goto yy940;
yy947:
		YYDEBUG(947, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy956;
		}
		goto yy940;
yy948:
		YYDEBUG(948, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy951;
		}
		goto yy940;
yy949:
		YYDEBUG(949, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(950, *YYCURSOR);
		if (yych <= '/') goto yy945;
		if (yych <= '9') goto yy949;
		if (yych == '_') goto yy939;
		goto yy945;
yy951:
		YYDEBUG(951, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(952, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy951;
		}
		if (yych != '_') goto yy945;
yy953:
		YYDEBUG(953, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '@') {
			if (yych <= '/') goto yy940;
			if (yych >= ':') goto yy940;
		} else {
			if (yych <= 'F') goto yy954;
			if (yych <= '`') goto yy940;
			if (yych >= 'g') goto yy940;
		}
yy954:
		YYDEBUG(954, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(955, *YYCURSOR);
		if (yych <= 'F') {
			if (yych <= '/') goto yy945;
			if (yych <= '9') goto yy954;
			if (yych <= '@') goto yy945;
			goto yy954;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy945;
				goto yy953;
			} else {
				if (yych <= '`') goto yy945;
				if (yych <= 'f') goto yy954;
				goto yy945;
			}
		}
yy956:
		YYDEBUG(956, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(957, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy956;
		}
		if (yych != '_') goto yy945;
yy958:
		YYDEBUG(958, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy940;
		if (yych >= '2') goto yy940;
yy959:
		YYDEBUG(959, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(960, *YYCURSOR);
		if (yych <= '/') goto yy945;
		if (yych <= '1') goto yy959;
		if (yych == '_') goto yy958;
		goto yy945;
yy961:
		YYDEBUG(961, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(962, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy961;
		}
		if (yych != '_') goto yy945;
yy963:
		YYDEBUG(963, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy940;
		if (yych >= '8') goto yy940;
yy964:
		YYDEBUG(964, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(965, *YYCURSOR);
		if (yych <= '/') goto yy945;
		if (yych <= '7') goto yy964;
		if (yych == '_') goto yy963;
		goto yy945;
	}
}


emit_token_with_str:
	zend_copy_value(zendlval, (yytext + offset), (yyleng - offset));

emit_token_with_val:
	if (PARSER_MODE()) {
		ZEND_ASSERT(Z_TYPE_P(zendlval) != IS_UNDEF);
		elem->ast = zend_ast_create_zval_with_lineno(zendlval, start_line);
	}

emit_token:
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	return token;

emit_token_with_ident:
	if (PARSER_MODE()) {
		elem->ident = SCNG(yy_text);
	}
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	return token;

return_whitespace:
	HANDLE_NEWLINES(yytext, yyleng);
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, T_WHITESPACE, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	if (PARSER_MODE()) {
		start_line = CG(zend_lineno);
		goto restart;
	} else {
		return T_WHITESPACE;
	}

skip_token:
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	start_line = CG(zend_lineno);
	goto restart;
}
